********************************************************************************
*                                                                              *
*  2DHF version 2-2006                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### blas ###
c
c     This is a replacement for BLAS routines: dcopy, daxpy, dscal, ddot, mxv.
c     Note that ix and iy are ignored and are set to 1.

c	$Id: blas.f,v 1.2 2006/06/27 22:06:12 jkob Exp $	

      subroutine  dcopy(n,dx,ix,dy,iy)
      integer*4 i,ix,iy,n
      real*8  dx(*),dy(*)

      do i=1,n
         dy(i)=dx(i)
      enddo
      return
      end

      subroutine  daxpy(n,da,dx,ix,dy,iy)
      integer*4  i,ix,iy,n
      real*8 da,dx(*),dy(*)

      do i=1,n
         dy(i)=da*dx(i)+dy(i)
      enddo
      return
      end

      subroutine  dscal(n,da,dx,ix)
      integer*4 i,ix,n
      real*8 da,dx(*)

      do i=1,n
         dx(i)=da*dx(i)
      enddo
      return
      end

      function  ddot(n,dx,ix,dy,iy)
      integer*4  i,ix,iy,n
      real*8  dx(*),dy(*),ddot

      ddot=0.d0
      do i=1,n
         ddot=ddot+dx(i)*dy(i)
      enddo
      return
      end


c     Multiplies the matrix DX(nr,nc) times the vector DV(nc) and stores 
c     the result in the vector DY(nr) by means of calling DGEMV 
c
      subroutine dgemv (trans,nr1,nc,alpha,dx,nr2,dv,incr1,beta,
     &     dvr,incr2)
      integer*4  incr1,incr2,inr,nc,nr1,nr2
      real*8  alpha,beta,dx(nr1,nc),dv(nc),dvr(nr1),s
      character*1 trans

      do inr=1,nr1
         s=0.d0
         do inc=1,nc
            s=s+dx(inr,inc)*dv(inc)
         enddo
         dvr(inr)=s
      enddo

      return
      end



                      












