********************************************************************************
*                                                                              *
*  2DHF version 2-2006                                                         *
*  Copyright (C) 2006 Jacek Kobus                                              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### checkfplen ###

c     Checks whether floting-point data stored in a file are of double
c     or quadrupole precision and returns checkfplen=8 or 16,
c     respectively.
      
      function checkfplen()
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)

      integer*4 i4tmp1,i4tmp2,i4tmp(10)
      integer*8 i8tmp1,i8tmp2,i8tmp(10)

      real*8 r8tmp1,r8tmp

      include 'commons8.inc'

      rewind(iinp11)
      read(iinp11,err=1000) header_p
      read(iinp11,err=1000) datetime_p

      if (lengthint.eq.4) then
         read(iinp11,err=1000) i4tmp1,i4tmp2,i4tmp
         ngrids_p=i4tmp1
         nni_p   =i4tmp2 
         do i=1,10
            nmu_p(i)=i4tmp(i)
         enddo 
      else
         read(iinp11,err=1000) i8tmp1,i8tmp2,i8tmp
         ngrids_p=i8tmp1
         nni_p   =i8tmp2 
         do i=1,10
            nmu_p(i)=i8tmp(i)
         enddo 
      endif

      read(iinp11,err=1020) r8tmp1,r8tmp
      read(iinp11,err=1020) r8tmp1,r8tmp
      checkfplen=8
      rewind(iinp11)
      return

 1020 continue
      checkfplen=16
      rewind(iinp11)
      return

 1000 continue
      write(iout6,'(//1x,"checkfplen: cannot read data from disk"//)')
      stop 'checkintlen'
      end
