********************************************************************************
*                                                                              *
*  2DHF version 2-2006                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### difni ###

c    This routine calculates 

c     (\frac{\partial^2}{\partial\ni^2} + 
c           d(\ni,\mu) \frac{\partial}{\partial \ni}) f(\ni,\mu)

c     The function is imersed in the array f(nni+8,nmut+8)
c     To allow for the differentiation over ni variable in the form
c     of matrix times vector the array f has to be transposed first.
c     Results of differentiation are stored directly column-wise in 
c     another matrix which means doing back tranposition before 
c     returning to a calling routine.

c     This routine differentiates a function over ni variable.
c     the function is imersed in the array f(nni+6,nmut+6)

c     $Id: difni.f,v 1.3 2006/06/28 20:39:00 jkob Exp $	

      subroutine difni (n,f,fd,wtran1,wtran2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      character*1 trans
      data trans/'n'/,incr/1/,alpha/1.d0/,beta/0.d0/
      data n9/9/
      dimension f(nni+8,n+8),fd(nni+8,n+8),
     &          wtran1(n+8,nni+8),wtran2(n+8,nni+8)

c     To allow for the differentiation over ni variable in the form
c     of matrix times vector the array f has to be transposed first.
c     Results of differentiation will be stored directly
c     column-wise in another matrix which means doing back tranposition
c     before returning to calling routine.  

      nni8=nni+8
      n8=n+8
      call gmtran (f,wtran1,nni8,n8)

c     FC3, ifort: error while passing 9 to a subroutine 

      do j=1,nni
c         call mxv (wtran1(1,j),n8,dni(1,j),n9,wtran2(1,j+4))
         call dgemv (trans,n8,n9,alpha,wtran1(1,j),n8,dni(1,j),incr,
     &        beta,wtran2(1,j+4),incr)
      enddo

      call gmtran(wtran2,fd,n8,nni8)

      return
      end

      subroutine dif1ni (n,f,fd,wtran1,wtran2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      character*1 trans
      data trans/'n'/,incr/1/,alpha/1.d0/,beta/0.d0/
      data n9/9/
      dimension f(nni+8,n+8),fd(nni+8,n+8),
     &          wtran1(n+8,nni+8),wtran2(n+8,nni+8)

c     To allow for the differentiation over ni variable in the form
c     of matrix times vector the array f has to be transposed first.
c     Results of differentiation will be stored directly
c     column-wise in another matrix which means doing back tranposition
c     before returning to calling routine.  

      call gmtran (f,wtran1,nni+8,n+8)

c     FC3, ifort: error while passing 9 to a subroutine 

      nni8=nni+8
      n8=n+8
      do j=1,nni
c         call mxv (wtran1(1,j),n8,d1ni(1,j),n9,wtran2(1,j+4))
         call dgemv (trans,n8,n9,alpha,wtran1(1,j),n8,dni(1,j),incr,
     &        beta,wtran2(1,j+4),incr)

      enddo

      call gmtran(wtran2,fd,n8,nni8)

      return
      end


