********************************************************************************
*                                                                              * 
*  2DHF version 2-2006                                                         *
*  Copyright (C) 2006 Jacek Kobus                                              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### fdftpot ###

c     Calculates the coefficients appearing in the LDA potential formulea.

      real*8 function fdftpot (alpha)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (const13=1.d0/3.d0,const23=2.d0/3.d0,const34=3.d0/4.d0)
      include 'commons8.inc'

      if (idftex.eq.1) then

c         fldapot=-alphaf*three/two*(three/pii)**const13

c        In case of the spin local density approximation where 
c        \rho_{total}^{1/3}=\sum_{spinorbital i} 
c                           [rho_{\alpha}^{1/3}(i) + \rho_{\beta}^{1/3}(i)]
c        an additional factor 2**(-2/3) shows up

         fdftpot=-alpha*three/two*(three/pii)**const13/two**(const23)

c according to ACES
c         fdftpot=-alpha*three/two*(three/pii)**const13*two**(const13)

      elseif (idftex.eq.2) then
c        D.Becke Phys. Rev. A 38 (1988) 3098
         fdftpot=-alpha*three/two*(three/pii)**const13/two**(const23)

      elseif (idftex.eq.3) then
c        generalized gradient approximation (GGA)
c        Perdew & Wang Phys. Rev. B 33 (1986) 8800
         fdftpot=-const34*(three/pii)**const13

      endif

      return
      end


