

#include <math.h>
double AM_HK_ZSimpson(double x, double y, double z);

//wywoanie: m=0, 
//jeli a=0 -> potencja kulombowski
//jeli a>0 -> potencja modelowy
double atom_pot_cyl_(double z, double s, int a, int m)
{
	double popr_cylind = (s==0.0?(m*m)/(2*0.0000000001):(m*m)/(2*s*s));

	return -1.0/sqrt(a*a+z*z+s*s)+popr_cylind;
}



//FUNKACJA ZWRACAJCA WARTO POTENCJAU
//-------------------------------------------------
//W rwn. Schr. wyeliminowana pierwsza pochodna
//w cylindrycznych: x->z, y->s
//+ poprwaka (ukad wsp. cylindrycznych)
//m=0
double AM_HK_Cyl_(double z, double s, int m)
{
	//jeeli rwn. jest z pierwsz pochodn 
    	double popr_cylind = (s==0.0?(m*m)/(2*0.0000000001):(m*m)/(2*s*s));

	//brak pierwszej pochodnej
    	//double popr_cylind = (s==0.0?(m*m-0.25)/(2*0.0000000001):(m*m-0.25)/(2*s*s));

        return AM_HK_ZSimpson(z, s, 0.0)+popr_cylind;
}

//FUNKACJE POMOCNICZE
//-------------------------------------------------
//potencja HK
double AM_HK(double t, double x, double y, double z)
{
    double a=1, w=1, e0=5; 
    double alpha0=e0/(w*w), bx=x+alpha0+alpha0*(cos(w*t)-1);
    return -1.0/((2*M_PI/w)*sqrt(a*a+bx*bx+y*y+z*z));
}


//numeryczne cakowanie
double AM_HK_ZSimpson(double x, double y, double z)
{
    int Nt=10000;
    double T=2*M_PI, h=T/Nt;
    double parts[3];
    double t=T-h;
    int i,k;
    parts[0]=parts[1]=0;
    parts[2]=AM_HK(0,x,y,z)+AM_HK(T,x,y,z);
    for (i=Nt,k=0; --i; t-=h,k=!k)
    	parts[k] += AM_HK(t,x,y,z);

    return (parts[2]+2*parts[1]+4*parts[0])*h/3;
}
