
      integer*4 cw_orb_add(1),cw_coul_add(1),cw_exch_add(1),
     &		cw_suppl_add(1),cw_sctch_add(1),cw_sor_add(1), 
     &		length,offset1,offset2,offset3,offset4,
     &		offset5,offset6
      include 'commons8.inc'

c     set number of additional arrays
      nsuppl=14
      nsctch=14

c     no and nons denote the number of all the orbitals and number 
c     of non sigma type orbitals, respectively. ni and mu correspond to
c     the number of grid points in ni and mu variables.

100   continue

c     read input data and echo input parameters
c     open input/output files

      call rinputd(iform,ni,mu,no,nons)

      ni8=ni+8
      mu8=mu+8
      ngrid=ni*mu
      ngrid8    = ni8*mu8

      length1   = no*ngrid
      length2   = no*ngrid

      if     (iform.eq.1.or.iform.eq.3) then
         length3=( no*(no+1)/2+nons*(nons+1)/2 )*ngrid
      elseif (iform.eq.0.or.iform.eq.2) then
         length3 = (no+nons)*ngrid	 
      endif

c     if HFS or OED method of calculation is chosen set length3 to
      
      if (imethod.eq.2) length3 = ngrid	 

      if (imethod.eq.3.and.iscmc.eq.0) length3 = ngrid	 
      

      length4   = nsuppl*ngrid
      length5   = nsctch*ngrid8     

      length6   = 2*ngrid8+4*ni*(mu+16)+2*maxgrids*(ni+mu)
      lexchrecl = ni*mu*8

c     dynamic allocation of memory acccording to the current case 

      length=8*length1
      call memalloc (cw_orb_add,  length1, 8, offset1)

      length=8*length2
      call memalloc (cw_coul_add, length2, 8, offset2)
	
      length=8*length3
      call memalloc (cw_exch_add, length3, 8, offset3)

      length=8*length4
      call memalloc (cw_suppl_add,length4, 8, offset4)

      length=8*length5
      call memalloc (cw_sctch_add,length5, 8, offset5)

      length=8*length6
      call memalloc (cw_sor_add,  length6, 4, offset6)

c     zeroise arrays

      call zeroarray (cw_orb_add(offset1),cw_coul_add(offset2),
     &     cw_exch_add(offset3),cw_suppl_add(offset4),
     &     cw_sctch_add(offset5),cw_sor_add(offset6))


c     initialize arrays within common blocks, 
c     initialize arrays of variable length and check input data
c     prepare an environment for poisson's equation solving routines
c     prepare arrays determining ordering of mesh points

      call inisuppl (cw_suppl_add(offset4),cw_sor_add(offset6))
c     print out data defining the case

      call printall

c     initialize orbitals, Coulomb and exchange potentials

      call inifun (cw_orb_add(offset1),cw_coul_add(offset2),
     &     cw_exch_add(offset3),cw_suppl_add(offset4),
     &     cw_sctch_add(offset5))

c  perform scf

      call  scf (cw_sor_add(offset6),cw_orb_add(offset1),
     &     cw_coul_add(offset2),cw_exch_add(offset3),
     &     cw_suppl_add(offset4),cw_sctch_add(offset5))

      if (icont.gt.0) goto 100 

      call memdealloc (cw_orb_add,  length1, 8, offset1)
      call memdealloc (cw_coul_add, length2, 8, offset2)
      call memdealloc (cw_exch_add, length3, 8, offset3)
      call memdealloc (cw_suppl_add,length4, 8, offset4)
      call memdealloc (cw_sctch_add,length5, 8, offset5)
      call memdealloc (cw_sor_add,  length6, 4, offset6)


