********************************************************************************
*                                                                              *
*  2DHF version 2-2006                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### ortho ###

c     Orthogonalizes a given orbital.

c FIXME
c     orthox and rotate are not used.
      
      subroutine ortho (iorb1,psi,f4,wgt2,wk0,iprt)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),f4(*),wgt2(*),wk0(*)
      dimension ovla(60),istp(60)

      jor=0
      ibeg1 = i1b (iorb1)
c ! orbitals are stored in reverse order
      do iorb2=1,norb
         iorb3=norb-iorb2+1
         if (iorb3.le.iorb1) go to 101
         
         ngrid= min (i1si(iorb1),i1si(iorb3))	  	    
         if (mgx(6,iorb3).ne.mgx(6,iorb1)) go to 101
         if (ige(iorb3).ne.ige(iorb1)) go to 101
c        uhf
c         if (spin(4*iorb3+1).ne.spin(4*iorb1+1)) goto 101
         
         jor=jor+1
         ibeg3= i1b (iorb3 )
         istp(jor)=ibeg3
         
         call prod2 (ngrid,psi(ibeg1),psi(ibeg3),wk0)
         call prod  (ngrid,f4,wk0)
         
         dfac=1.d0
         ovla(jor)=dfac*ddot (ngrid,wgt2,1,wk0,1)

c        write final overlap
         if (iprt.ne.0.or.idbg(340).ne.0) then
            write(*,60) iorn(iorb1),bond(iorb1),gut(iorb1),
     &           iorn(iorb3),bond(iorb3),gut(iorb3),ovla(jor)
 60         format(4x,' <',i2,1x,a5,1x,a1,1x,'|',
     &           1x,i2,1x,a5,1x,a1,1x,'> = ',e10.2)     
         endif

         if (idbg(341).ne.0.and.nlm(iorb1,iorb3).ne.0) then
            write(*,60) iorn(iorb1),bond(iorb1),gut(iorb1),
     &           iorn(iorb3),bond(iorb3),gut(iorb3),ovla(jor)
         endif
 101     continue
      enddo
      
      if (iprt.eq.2) return

c     start orthogonalization

      if (jor.eq.0) return

      ano=0.d0
      do ira=1,jor
         ngrid= min (i1si(iorb1),i1si(ira))	  	    	
         ano=ano+ovla(ira)*ovla(ira)
         call daxpy (ngrid,-ovla(ira),psi(istp(ira)),1,psi(ibeg1),1)
      enddo

c     normalize the orthogonalized orbital isa  but be sure the
c     unorthogonalized isa was normalized otherwise use <isa/isa>
c     instead of 1. in ano

      ano=sqrt(1.d0+ano)/(1.d0-ano*ano)
      ngrid = i1si(iorb1)
      call dscal (ngrid,ano,psi(ibeg1),1)

c     Except for the lowest orbitals in any given symmetry the
c     normalization factors are not equal to unity through the scf
c     process. These orbitals aquire proper normaization upon completion
c     of the scf process. In order to force the normalization to unity
c     set idbg(200) to 1.

      if (idbg(200).eq.0) return

      call prod2 (ngrid,psi(ibeg1),psi(ibeg1),wk0)
      call prod  (ngrid,f4,wk0)
      
      ovla(jor)=ddot (ngrid,wgt2,1,wk0,1)
      ano=1.d0/sqrt(ovla(jor))
      call dscal (ngrid,ano,psi(ibeg1),1)

      return
      end

c ### orthox ###

      subroutine orthox (iorb1,psi,f4,wgt2,wk0,iprt)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),f4(*),wgt2(*),wk0(*)
      dimension ovla(60),istp(60)

      jor=0
      ibeg1 = i1b (iorb1)
c ! orbitals are stored in reverse order
      do iorb2=1,norb
         iorb3=norb-iorb2+1
c FIXME
c          if ( iorb1.eq.2.and.iorb3.eq.5 ) goto 102
c          if ( iorb1.eq.2.and.iorb3.eq.5 ) goto 102
c          if ( iorb1.eq.5.and.iorb3.eq.2 ) goto 102

c         if ( iorb1.eq.1.and.iorb3.eq.3 ) goto 102
         goto 101

 102     continue
         ngrid= min (i1si(iorb1),i1si(iorb3))	  	    
c         if (mgx(6,iorb3).eq.mgx(6,iorb1)) go to 101
c         if (ige(iorb3).eq.ige(iorb1)) go to 101
         
         jor=jor+1
         ibeg3= i1b (iorb3 )
         istp(jor)=ibeg3
         
         call prod2 (ngrid,psi(ibeg1),psi(ibeg3),wk0)
         call prod  (ngrid,f4,wk0)
         
         ovla(jor)=ddot (ngrid,wgt2,1,wk0,1)

c        write final overlap
c         if (idbg(342).ne.0) then
c            write(*,60) iorn(iorb1),bond(iorb1),gut(iorb1),
c     &           iorn(iorb3),bond(iorb3),gut(iorb3),ovla(jor)
c         endif

 60      format(4x,' <',i2,1x,a5,1x,a1,1x,'|',
     &           1x,i2,1x,a5,1x,a1,1x,'> = ',e10.2)     
 101     continue
      enddo
c     start orthogonalization

      if (jor.eq.0) return

      ano=0.d0
      do ira=1,jor
         ngrid= min (i1si(iorb1),i1si(ira))	  	    	
         ano=ano+ovla(ira)*ovla(ira)
         call daxpy (ngrid,-ovla(ira),psi(istp(ira)),1,psi(ibeg1),1)
      enddo

c     normalize the orthogonalized orbital isa  but be sure the
c     unorthogonalized isa was normalized otherwise use <isa/isa>
c     instead of 1. in ano

      ano=sqrt(1.d0+ano)/(1.d0-ano*ano)
      ngrid = i1si(iorb1)
      call dscal (ngrid,ano,psi(ibeg1),1)

c     Except for the lowest orbitals in any given symmetry the
c     normalization factors are not equal to unity through the scf
c     process. These orbitals aquire proper normaization upon completion
c     of the scf process. In order to force the normalization to unity
c     set idbg(200) to 1.

      return
      end

c ### rotate ###

      subroutine rotate (iorb1,psi)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*)
      common /status/ istat

      if (istat.eq.1) return
      if (iorb1.ne.2) return
      istat=1

      a=1.d-4
      b=sqrt(1.d0-a*a/2.d0)
      print *,'rotate: ',a

c this is to rotate a pair of nonorthogonal pi-type orbitals
      iorb2=5
      ibeg1 = i1b (iorb1)
      ibeg2 = i1b (iorb2)
c ! orbitals are stored in reverse order
      ngrid= min (i1si(iorb1),i1si(iorb2))	  	    

c     psi1*=b*psi2 + a*psi1
c     psi1*=b*psi1 + a*psi2
      call dscal(ngrid,b,psi(ibeg1),1)
      call daxpy(ngrid,a,psi(ibeg2),1,psi(ibeg1),1)

         
c     psi2*= a*psi2 + b*psi1
c     psi2*= -a*psi1 + b*psi2
      call dscal(ngrid,b,psi(ibeg2),1)
      call daxpy(ngrid,-a,psi(ibeg1),1,psi(ibeg2),1)

      return
      end
