********************************************************************************
*                                                                              * 
*  2DHF version 2-2006                                                         *
*  Copyright (C) 2006 Jacek Kobus                                              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### qvwn ###

c     Calculates q function of VWN functional (see
c     http://wild.life.nctu.edu.tw/~jsyu/molpro2002.1/doc/manual/node184.html)

      real*8 function qvwn(x,a,p,c,d)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'	

      xcap=x*x+c*x+d
      qcap=sqrt(four*d-c*c)      
      arctan=atan(qcap/(two*x+c))

      t1=log(x*x/xcap)
      t2=two*c/qcap*arctan
      t3=-c*p/xcap*(log((x-p)*(x-p)/xcap) +two*(c+two*p)/qcap*arctan)
      
      qvwn=a*(t1+t2+t3)
      return
      end

