
********************************************************************************
*                                                                              * 
*  2DHF version 2-2006                                                         *
*  Copyright (C) 2006 Jacek Kobus                                              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### qvwnderx ###

c     Calculates dq/dx of the VWN functional 

      real*8 function qvwnderx(x,a,p,c,d)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'	

c X=xcap, dX/dx=xcapder 
      xcap=x*x+c*x+d
      xcapder=two*x+c
      xcapder2=xcapder*xcapder

      xcapp=p*p+c*p+d

      qcap=sqrt(four*d-c*c)      
      qcap2=(four*d-c*c)      

      t1=two/x-xcapder/xcap
      t2=-four*c/(qcap2+xcapder2)
      t3=four*c*p*(c+two*p)/xcapp/(qcap2+xcapder2)
      t4=-c*p/xcapp*(two/(x-p)-xcapder/xcap)
      
      qvwnderx=a*(t1+t2+t3+t4)
      return
      end

