********************************************************************************
*                                                                              * 
*  2DHF version 2-2006                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rinputd ###
c
c     Handles the input to 2DHF.
c
      subroutine rinputd(iform_t,ni_t,mu_t,no_t,nons_t)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (nmethods=5,nlabels=37,maxflags=20)
      character*4 cdftext(10),cdftcorrt(10)
      character*8 clabel,char8
      character*8 labellc(nlabels),cmethod(nmethods),pab(3)
      character*8 sigma,sigmag,sigmau,pi,delta,phi,space,angstrom,
     &     endl
      character*20 caseinp,psiinp,coulinp,exchinp,
     &             caseout,psiout,coulout,exchout

      include 'commons8.inc'
      include 'commons8a.inc'

      dimension id(maxflags)
      data labellc /
     &     'break','canon','config','cont','conv',
     &     'cutoff','debug','dft','inout','fefield',
     &     'fermi','fix','gauss','grid','harm2xy',
     &     'help','homo','initial','interp','lagra',
     &     'lagraon','maxsor','method','multipol','nuclei',
     &     'omega','order','print','scf','scforder',
     &     'sor','stop','subgrid','title','xalpha',
     &     'poth3','potkh'/
c
      data cdftext /
     &     'lda','b88','pw86','pw91','','','','','',''/
      data cdftcorrt /'lyp','vwn','','','','','','','',''/

      data angstrom/'angstrom'/,
     &     cmethod/'hf','oed','hfs','dft','scmc'/,
     &     endl/'end'/,
     &     pab/'u','g',' '/,      
     &     space/'    '/
      data sigma/'sigma'/,pi/'pi'/,delta/'delta'/,phi/'phi'/,
     &     sigmag/'sigma g'/,sigmau/'sigma u'/

      data inpiexit/-99999/

      do i=1,10
         cdftex(i)=cdftext(i)
         cdftcorr(i)=cdftcorrt(i)
      enddo

      call banner

      call  getdatetime(datetime)
      dtstart=datetime

c     no=isum=norb
c     iexd=maxorb
c     bond=orbsym

      inpform=0
      ioutform=0
      inout32=0
      inout64=0
      inout128=0

c     2dhf_input.dat is assumed
      idat=0

c  set some constants
      call setconst

c     default data input format depends on compilation options
      lengthintin=lengthint
      lengthfpin=lengthfp

c     set format of floating-point numbers
      if (lengthfpin.eq.8) then
         formfp=formfp64
      else
         formfp=formfp128
      endif   

c     printout according to the precision used
      if (precis.gt.1.d-20) then
         iprint16=0
      else
         iprint16=1
      endif
c      iprint16=1
c  initialization of some variables

      ihomon=0
      ibreak=0
      iinterp=0
     
      cutorb =1.d-6
      cutcoul=1.d-6
      cutexch=1.d-6
      iftail  =13    

c     diver  -  if demax(1) in proce is greater than diver
c               divergence in the scf process is detected and
c               the program stops

      diver = 1.d20   

c     default canonicalization coefficients

      icanon=1
      
c     multipol default value; the order of multipole expansion cannot
c     exceed maxmpole-1 (and mpole maxmpole)

      mpole=4

c     default number of grids and the default ordering of mesh points
      ngrids=1
      iorder(ngrids)=2

c     scf default values
      
      maxscf  = 1000
      nobckup =  100
      ienterm =   10
      inoterm =   10
      iprtlev =    2
      facmul  =    1.15d0

c     fix default values

      iexlorb  = 0
      iexlcoul = 0
      iexlexp  = 2
   
      exlorb  = 0.d0
      exlcoul = 0.d0
      exlexp  = 2.d0


c     HF method is chosen as a default
      imethod=1

c FIXME
c     HFS switches LDA (Slater, Xalpha) approximation
c     if the approximation is switched on by default formulae due to
c     Laaksonen, Pyykko, Sundholm are used (see fdftpot, fdften)

c     by default DFT approach is not used
      idft=0
      idftex=0
      idftcorr=0
      alphaf = two/three
      iscmc=0

c     sor default value
      maxsor2 =10
      maxsor1 = 1
      lsor    = 1
      ipoiss  = 1

c     skip nscf2skip iterations before starting the search for
c     saturation; examine the last nenlast and nnolast iterations in case
c     of orbital energy and normalization, respectively

      nscf2skip=600
      nenlast=20
      nnolast=20

c     fermi default value (point nuclei)

      ifermi=0
      
c     plot default value (no data exported for making plots)

      iplot=0
      
c     additional relaxation of the least relaxed orbital is switched off
c     facrel is no longer used	

      facrel=-10.d0

c     search for optimal value of the overrelaxation parameter is
c     switched off
      
      search=1.d-15
      omincr=0.0d0
      
      sflagra=1.d0
      dflagra=0.d0

      ifefield=0
      ffield =0.d0
      fgrad  =0.d0
      zcutoff=1.d5
      iharm2xy=0
      
      cmass =0.d0
      cmass1=0.d0

c     default order of interpolation polynomials when changing grids 
c     for orbitals and potentials

      iord_nu_orb=5
      iord_nu_coul=5
      iord_nu_exch=5
      
      iord_mu_orb=5
      iord_mu_coul=5
      iord_mu_exch=5

c     array iscforder is used to change the defaukt order of relaxation
c     of orbitals during scf process

      do i=1,maxorb
         iscforder(i)=0
      enddo

      incrni=10
      incrmu=10

      do i=1,maxorb
         gut(i)  ='        '
         bond(i) ='        '
      enddo
      do i=1,4*maxorb
         spin(i) ='        '
      enddo

      do i=1,2*maxorb
         lagraon(i)=0
      enddo


      do i=1,600
         idbg(i)=0
         iprint(i)=0
      enddo

      do i=1,100
         itail(i)=0
      enddo

c     set maximum allowed unit number
      call setmaxunit()

      write(*,*) '  ... start of input data ...'
c      write(*,*)'        '

 5    continue
      
      call card
      call inpa(clabel)
      
      do i=1,nlabels
         if (clabel.eq.labellc(i)) go to 12
      enddo
      goto 1530

c cont?

C$$$      data labellc /
C$$$     &     'break','canon','config','cont','conv',
C$$$     &     'cutoff','debug','dft','export','fefield',
C$$$     &     'fermi','fix','gauss','grid','harm2xy',
C$$$     &     'help','homo','initial','interp','lagra',
C$$$     &     'lagraon','maxsor','method','multipol','nuclei',
C$$$     &     'omega','order','print','scf',
C$$$     &     'scforder','sor','stop','subgrid','title',
C$$$     &     'xalpha'/

 12   go to (
     &     510,520,530,540,550,
     &     560,570,580,590,600,
     &     610,620,630,640,650,
     &     660,670,680,690,700,
     &     710,720,730,740,750,
     &     760,770,780,790,800,
     &     810,820,830,840,850,
     &     860,870), i
      stop


 510  continue

c     label label label label label label label label label label label label label 
c     label: break 

c     switch on symmetry breaking

      ibreak=1
      go to 5


 520  continue

c     label label label label label label label label label label label label label 
c     label: canon

c     choice of canonication coefficients due to
c     Davidson (default)       - 1
c     Guest and Saunders       - 2
c     Roothaan (single matrix) - 3
c     McWeeny and Diercksen    - 4

      call inpi(icanon)
      goto 5


 530  continue

c     label label label label label label label label label label label label label 
c     label: config

c     read total charge for the system

cc FIXME r128  dble  inpf 1d0->1q0
      call inpi(itotq)
      totq=z1+z2-dble(itotq)

c     to allow for noninteger nucleus charge needed to force convergence
c     in some open-shell cases read in the nuclei charges again

      z1t=0.d0
      z2t=0.d0
      call inpf(z1t)
      call inpf(z2t)
      if (z1t.gt.precis) z1=z1t
      if (z2t.gt.precis) z2=z2t

c     read in symmetry and occupation and test if
c     the orbital is locked = 1 (open shell case)
c                           = 0 (closed shell case)
      isum=0
 82   call card
      call inpi(nbsym)
      call inpa(char8)

      if(char8.ne.sigma.and.char8.ne.pi.and.
     &     char8.ne.delta.and.char8.ne.phi) then
	 write(iout6,*) 'Error: wrong symmetry or symmetry higher',
     &        ' than phi'
         stop 'rinputd'
      endif

      isum0=isum
      do i=1,nbsym
         isum=isum+1
         orbsym(isum)=char8
	 bond(isum)=orbsym(isum)
         gut(isum)=space
      enddo
      
      if (isum.gt.maxorb) then
         write(iout6,*) 'too many orbitals (max. see maxorb)'
         stop 'rinputd'
      endif
      
c     in homonuclear case read in the parity of each orbital 
c     if BREAK is on (ibreak=1) u/g labels are ignored
c     if |z1-z2|<homolevl then the case is treated as a homonuclear one
c     homolevl is set to 1.0e-6 (see blk_data.inc) 

      if (abs(z1-z2).lt.homolevl.and.ibreak.eq.0) then
         call inpa(gut(isum))
         isum1=isum0
         do i=1,nbsym
            isum1=isum1+1
            gut(isum1)=gut(isum)
         enddo
      endif
      
      cloe=4.d0
      if (orbsym(isum).eq.sigma) cloe=2.d0
      iput=4*(isum-1)
      call inpa(char8)
      if (char8.ne.endl) then
         spin(1+iput)=char8
         call inpa(char8)
         if (char8.ne.endl) then 
            spin(2+iput)=char8
            call inpa(char8)
            if (char8.ne.endl) then
               spin(3+iput)=char8
               call inpa(char8)
               if (char8.ne.endl) then
                  spin(4+iput)=char8
                  call inpa(char8)
               endif
            endif
         endif
      endif


      if (spin(1+iput).ne.'+'.and.spin(1+iput).ne.'-') then
         do i=1,nbsym
            occ(isum0+i)= cloe
         enddo
C          if (spin(1+iput).eq.'.'.and.spin(2+iput).eq.'.'.and.
C      &       spin(3+iput).eq.'.'.and.spin(4+iput).eq.'.') then 
C             do i=1,nbsym
C                occ(isum0+i)=0
C             enddo
C             spin(1+iput)='+'
C             spin(2+iput)='-'
C             spin(3+iput)='+'
C             spin(4+iput)='-'
C          endif

      else
         do i=1,4
            if (spin(i+iput).eq.'+'.or.spin(i+iput).eq.'-') then
               do j=1,nbsym 
                  occ(isum0+j)=occ(isum0+j)+1.d0
               enddo
            endif
         enddo
      endif
      norb=isum
      no=norb
      
c     initialize scaling factors for off-diagonal Lagrange multipliers

      do i=1,norb
         do j=i+1,norb
            sflagrat(i,j)=sflagra
         enddo
      enddo

c     initialize SOR parameters

      do i=1,norb
         maxsor(i)=maxsor2
      enddo

      if (char8.eq.endl) then
         totchar=0.d0
         do iorb=1,norb
            totchar=totchar+occ(iorb)
         enddo

c        Warning!
c        on Cray Y-MP (F90) the calculated charge was 29. and the one 
c        read in -- 29.00000000000011. 
c        The statement if (totchar.eq.totq) had to be replaced by the following
c        one

c FIXME r128 
         if (abs(totchar-totq).gt.precis*1000.0) then
            write(iout6,*) 'Error: mismatch in given and',
     &           ' calculated total charge:',totchar,totq
c FIXME !!!! OED is effected
c            stop 'rinputd' 
        endif
         goto 5
      endif
      goto 82



 540  continue

c     label label label label label label label label label label label label label 
c     label: cont

      icont=icont+1
      write(*,*) '  ... end of input data for case',icont, ' ...'
      write(*,*)'        '
      icont=icont+1

      iform_t = iform
      ni_t    = nni
      mu_t    = nmutot
      no_t=norb
      nons_t=0
      do iorb=1,norb
         if (mgx(3,iorb).ne.0) nons_t=nons_t+1
      enddo
      goto 1000
      

 550  continue

c FIXME
c     label label label label label label label label label label label label label 
c     label: conv [nscf2skip [nnenlast [nnolast] ] ] 

      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         nscf2skip=itmp
         call inpi(itmp)
         if (itmp.ne.inpiexit) then
            nenlast=itmp
            call inpi(itmp)
            if (itmp.ne.inpiexit) then
               nnolast=itmp
            endif
         endif
      endif
      goto 5


 560  continue
c FIXME 
c     label label label label label label label label label label label label label 
c     label: cutoff -- cutoff values for orbitals and potentials


      call inpi(itmp)
      if (itmp.ge.0) iftail=itmp
      goto 5


 570  continue

c FIXME update documentation (extra label?)

c     label label label label label label label label label label label label label 
c     label: debug

c     idbg    -  additional printout
c     incrni  -  parameters of pmtx routine used to print matrice
c     incrmi	 row-wise. every incrni row and every incrmi column
c		 are printed

c     idbg  -  additional printout for testing purposes

c     set debug flags. if an integer i is encountered debuf flag i
c     is set, i.e. idbg(i)=1. at most 15 integers (1<i<100) can
c     be specified. if fewer integers are in the record terminate
c     it by a slash.



      inzero=1
      do i=1,maxflags
         id(i)=0
         call inpi(id(i))
         if (id(i).gt.0) then
           inzero=inzero+1
           idbg(id(i))=1
        endif
      enddo
c FIXME
      write(iout6,1110) (id(i),i=1,inzero)
      if (idbg(301).ne.0) then
         write(*,*) "rinputd: Warning! ",
     &        "Do you realy want to use this flag?!"
      endif
 1110 format(10i7)
      
      if (idbg(600).eq.1) then
         call card
         call inpi(incrni)
         call inpi(incrmu)
      endif


c FIXME
      if (idbg(599).eq.1) then
         call card
         call inpi(iorb)
         read(*,*) (sflagrat(iorb,i),i=iorb+1,norb)
         
         do i=iorb+1,norb
            sflagrat(i,iorb)=sflagrat(iorb,i)/2.d0
         enddo
         write(*,'(10e12.2)') (sflagrat(iorb,i),i=iorb+1,norb)
      endif


      goto 5


 580  continue

c     label label label label label label label label label label label label label 
c     label: dft [lda|b88] [lyp] [vwn]

c FIXME xalpha is islat=1 and method=3 equivalent

c     if the DFT method is used one can choose exchange and correlation
c     energy functionals

c      call inpi(itmp)

c     if only dft label is present calculate exchange (LDA, B88,PW86,
c     PW91) and correlation (LYP) contributions to total energy at the
c     end of SCF process

      idft=1
      call inpa(char8)
      if (char8.ne.endl) then
         do i=1,10
            if (char8.eq.cdftex(i)) idftex=i
            if (char8.eq.cdftcorr(i)) idftcorr=i
         enddo
         call inpa(char8)
         if (char8.ne.endl) then
            do i=1,10
               if (char8.eq.cdftex(i)) idftex=i
               if (char8.eq.cdftcorr(i)) idftcorr=i
            enddo
         endif
      endif

      if (idftex.ne.0.or.idftcorr.ne.0) idft=0

c     some functionas are only valid for closed shell configurations


      if (idftex.gt.4) goto 1700
      if (idftcorr.gt.2) goto 1700
      
      if (idftex.ne.0) then 
         islat =1
         imethod=3
      endif

      if (idftcorr.ne.0) then 
         islat=1
         imethod=3
         if (idftex.eq.0) idftex=1
      endif

      goto 5


 590  continue

c     label label label label label label label label label label label label label 
c     label: inout i32|i64|r128

c     force format of input and output data

      lengthintin=lengthint
      lengthfpin=lengthfp
      inpform=0
      ioutform=0
      inout32=0
      inout64=0
      inout128=0
      call inpa(clabel)
      if     (clabel.eq.'i32') then 
         lengthintin=4
         lengthfpin=8
         inpform=0
      elseif (clabel.eq.'i32f') then 
         lengthintin=4
         lengthfpin=8
         inpform=1
         formfp=formfp64
      elseif (clabel.eq.'i64') then
         lengthintin=8
         lengthfpin=8
         inpform=0
      elseif (clabel.eq.'i64f') then
         lengthintin=8
         lengthfpin=8
         inpform=1
         formfp=formfp64
      elseif (clabel.eq.'r128') then
         lengthintin=8
         lengthfpin=16
         inpform=0
      elseif (clabel.eq.'r128f') then
         lengthintin=8
         lengthfpin=16
         inpform=1
         formfp=formfp128
      else
         goto 1700
      endif

      call inpa(clabel)
      if     (clabel.eq.'i32') then 
         inout32=1
         ioutform=0
      elseif (clabel.eq.'i32f') then
         inout32=2
         ioutform=1
      elseif (clabel.eq.'i64') then
         inout64=1
         ioutform=0
      elseif (clabel.eq.'i64f') then
         inout64=2
         ioutform=1
         formfp=formfp64
      elseif (clabel.eq.'r128') then
         inout128=1
         ioutform=0
      elseif (clabel.eq.'r128f') then
         inout128=2
         formfp=formfp128
         ioutform=1
         if (lengthfp.ne.16) then
            write(*,*) 'Error: present build of the program does not ',
     &           'support quadrupole precision'
            stop 'rinputd'
         endif
      else
         goto 1700
      endif

      goto 5


 600  continue      

c     label label label label label label label label label label label label label 
c     label: fefield

c     finite field calculations
c     1 field strength
c     2 gradient strength
      

      ifefield=1
c      call inpi(ifefield)
c      if     (ifefield.eq.1) then 
      call inpf(ffield)
      call inpf(tmp)
      if (tmp.ne.zero) zcutoff=tmp
 
c         write(*,*) 'ifefield,ffield ',ifefield,ffield
c      elseif (ifefield.eq.2) then 
c         call inpf(fgrad)
c         call inpf(zcutoff)
c      else
c         write(*,*) 'Error: incorrect type of finite ',
c     &        'field calculations'
c         stop 'rinputd'
c      endif
      goto 5


 610  continue      

c FIXME
c     label label label label label label label label label label label label label 
c     label: fermi

      call inpf(z1atmass)
      if (z1atmass.le.0.d0) then
         izz1=nint(z1)
         z1atmass=atweight(izz1)
      endif
      call inpf(z2atmass)
      if (z2atmass.le.0.d0) then
         izz2=nint(z2)
         z2atmass=atweight(izz2)
      endif
      if (z1atmass.le.0.d0.and.z2atmass.le.0.d0) then
         goto 1700
      endif
      ifermi=1
      goto 5


 620  continue

c     label label label label label label label label label label label label label 
c     label: fix

c     exlwf exlpot- if nonzero wave functions, coulomb potentials or
c     exlexp        exchange potentials are not relaxed; exlpot and 
c                   exlexp cannot be non zero if hydrogen orbitals 
c                   are used to start the scf process

      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         iexlorb=itmp
         call inpi(itmp)
         if (itmp.ne.inpiexit) then
            iexlcoul=itmp
            call inpi(itmp)
            if (itmp.ne.inpiexit) then
               iexlexp=itmp
            endif
         endif
      endif

      exlorb=dble(iexlorb)
      exlcoul=dble(iexlcoul)
      exlexp=dble(iexlexp)
      goto 5



 630  continue
c     label: gauss

      call inpf(z1atmass)
      if (z1atmass.le.0.d0) then
         izz1=nint(z1)
         z1atmass=atweight(izz1)
      endif
      call inpf(z2atmass)
      if (z2atmass.le.0.d0) then
         izz2=nint(z2)
         z2atmass=atweight(izz2)
      endif
      if (z1atmass.le.0.d0.and.z2atmass.le.0.d0) then
         goto 1700
      endif
      ifermi=2

      goto 5


 640  continue

c     label label label label label label label label label label label label label 
c     label: grid
      
      tmp1=0.d0
      tmp2=0.d0
      call inpi(nni)
      call inpf(tmp1)
      call inpf(tmp2)
      if (tmp2.ne.0.d0) then
c        nnu nmu R_infty
         nmu(ngrids)=tmp1
         rgrid(ngrids)=tmp2
      else
c        nni R_infty
         if (ngrids.ne.1) then
            write(*,*)'rinputd: missing item in GRID card'
            stop 'rinputd'
         endif
         rgrid(ngrids)=tmp1
         nmu(1)=nmucalc()
      endif
     
      rinf=rgrid(ngrids)
      nmutot=nmu(ngrids)

      if (nni.gt.maxni) then
         write(*,*) 'Error: too many grid points in nu variable:', 
     &        nni,' is greater than ',maxni
         stop 'rinputd'
      endif

      if (nmutot.gt.maxmu) then
         write(*,*) 'Error: too many grid points in mu variable:',
     &        nmutot,' is greater than ',maxmu
         stop 'rinputd'
      endif

      goto 5


 650  continue

c     label label label label label label label label label label label label label 
c     label: harm2xy

c     1 omega
c
c     one-electron calculations with additional potential
c            omega^2/2(x^2+y^2)
c     
      iharm2xy=1
      call inpf(harm2xy)
      
      goto 5


 660  continue

c     label label label label label label label label label label label label label 
c  label: help 

      write(*,*) '... no online help is available ...'
      write(*,*) '... see ./doc/users_guide.html or ',
     &     './doc/users_guide.pdf ...'
      stop 'rinputd'
      goto 5


 670  continue

c     label label label label label label label label label label label label label 
c     label: homo --  when this label is encountered the g/u symmetry of
c                     orbitals is strictly imposed; in all other respects
c                     a homonuclear case is treated as a heteronuclear one

c     ihomon=0 --  heteronuclear case
c     ihomon=1 --  homonuclear case |z1-z2|<homolevl (set in common block data)
c     ihomon=2 --  homonuclear case with forced symmetry

      ihomon=2
      goto 5


 680  continue

c     label label label label label label label label label label label label label 
c     label: initial

c     iform =0  read multiple exchange files &  write multiple exchange files
c     iform =1  read a single exchange file  &  write multiple exchange files
c     iform =2  read multiple exchange files &  write a single exchange file 
c     iform =3  read a single file           &  write a single exchange file 

c     initial default values
      inclorb = 1
      iform=3

      call inpi(ini)
      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         iform=itmp
         call inpi(itmp)
         if (itmp.ne.inpiexit) then
            inclorb=itmp
         endif
      endif

      if (imethod.eq.2) then
         if (ini.ne.1) ini=4 
         facmul=10.d0**(15)
      endif

      if (imethod.eq.3.and.iform.ne.3) then
         write(iout6,*) 'Error: if method is chosen as HFS ',
     &        'the second parameter has to be set to 3'
         stop 'rinputd'
      endif
      
      if (inclorb.eq.2) then

c        'hydrogen' initialization with screening

         do iorb=1,norb
            call card
            call inpf(co1(iorb))
            call inpi(mgx(1,iorb))
            call inpi(mgx(2,iorb))
            call inpf(eza1(iorb))
            eza1(iorb)=z1-eza1(iorb)
            call inpf(co2(iorb))
            call inpi(mgx(4,iorb))
            call inpi(mgx(5,iorb))
            call inpf(eza2(iorb))
            eza2(iorb)=z2-eza2(iorb)
            call inpi(ifix(iorb))
            call inpi(maxsor(iorb))
            if (maxsor(iorb).eq.inpiexit) maxsor(iorb)=maxsor2
            i1ng(iorb)=0
         enddo
      elseif (inclorb.eq.1) then

c        'hydrogen' initialization without screening

         do iorb=1,norb
            call card
            call inpf(co1(iorb))
            call inpi(mgx(1,iorb))
            call inpi(mgx(2,iorb))
            call inpf(eza1(iorb))
            eza1(iorb)=eza1(iorb)
            call inpf(co2(iorb))
            call inpi(mgx(4,iorb))
            call inpi(mgx(5,iorb))
            call inpf(eza2(iorb))
            eza2(iorb)=eza2(iorb)
            call inpi(ifix(iorb))
            call inpi(maxsor(iorb))
            if (maxsor(iorb).eq.inpiexit) maxsor(iorb)=maxsor2
            i1ng(iorb)=0
         enddo
      elseif (inclorb.eq.0) then
         
c        orbitals already initialized or taken from Gaussian output

         do iorb=1,norb
            maxsor(iorb)=maxsor2
            co1(iorb)=1.d0
            co2(iorb)=1.d0
         enddo
      else
         write(*,*) 'rinputd: Wrong value of the third parameter'
         stop 'rinputd'
      endif

      do iorb=1,norb
	if (i1ng(iorb).eq.0) then
	  i1ng(iorb)=ngrids
	  i2ng(iorb)=ngrids
	endif
      enddo

      do iorb=1,norb
         if (orbsym(iorb).eq.sigma) mt=0
         if (orbsym(iorb).eq.pi)    mt=1
         if (orbsym(iorb).eq.delta) mt=2
         if (orbsym(iorb).eq.phi)   mt=3

c        asymuthal quantum number of a hydrogen orbital is taken 
c        in accordance with the symmetry of a molecular orbital

         mgx(3,iorb)=mt
         mgx(6,iorb)=mt
         lock(iorb)=0

         clo=4.d0
         if (orbsym(iorb).eq.sigma) clo=2.d0
         clo=occ(iorb)/clo
	 if (abs(clo-1.d0).gt.1.d-06) then
	    lock(iorb)=1
	 endif

         mgi=(-1)**mgx(3,iorb)
      enddo

c     the program works on a set of standard input and output dump files
c     containing orbitals, Coulomb potentials (with extentions .orb and .pot, 
c     respectively), exchange potentials (fort.201, fort.202, ...) and
c     some additional data ( *.ext)

      caseinp ='2dhf_input.dat'
      psiinp ='2dhf_input.orb'
      coulinp='2dhf_input.coul'
      exchinp='2dhf_input.exch'
     
      caseout ='2dhf_output.dat'
      psiout ='2dhf_output.orb'
      coulout='2dhf_output.coul'
      exchout='2dhf_output.exch'

c     open separate files for reading and writing data defining a case
      open(iinp14,file=caseinp, status='unknown',form='formatted')
      open(iout24,file=caseout, status='unknown',form='formatted')

c     open separate files for reading and writing orbitals and potentials 

      if (iform.eq.0) then
         if (inpform.eq.0) then
            open(11,file=psiinp, status='unknown',form='unformatted')
            open(12,file=coulinp,status='unknown',form='unformatted')
            iinp13=iout23
         else
            open(11,file=psiinp, status='unknown',form='formatted')
            open(12,file=coulinp,status='unknown',form='formatted')
            iinp13=iout23
         endif

         if (ioutform.eq.0) then
            open(21,file=psiout, status='unknown',form='unformatted')
            open(22,file=coulout,status='unknown',form='unformatted')
         else
            open(21,file=psiout, status='unknown',form='formatted')
            open(22,file=coulout,status='unknown',form='formatted')
         endif
      elseif (iform.eq.1) then
         if (inpform.eq.0) then
            open(11,file=psiinp, status='unknown',form='unformatted')
            open(12,file=coulinp,status='unknown',form='unformatted')
            open(13,file=exchinp,status='unknown',form='unformatted')
            rewind(13)        
         else
            open(11,file=psiinp, status='unknown',form='formatted')
            open(12,file=coulinp,status='unknown',form='formatted')
            open(13,file=exchinp,status='unknown',form='formatted')
            rewind(13)        
         endif

         if (ioutform.eq.0) then
            open(21,file=psiout, status='unknown',form='unformatted')
            open(22,file=coulout,status='unknown',form='unformatted')
         else
            open(21,file=psiout, status='unknown',form='formatted')
            open(22,file=coulout,status='unknown',form='formatted')
         endif

      elseif (iform.eq.2) then
         if (inpform.eq.0) then
            open(11,file=psiinp, status='unknown',form='unformatted')
            open(12,file=coulinp,status='unknown',form='unformatted')
         else
            open(11,file=psiinp, status='unknown',form='formatted')
            open(12,file=coulinp,status='unknown',form='formatted')
         endif

         if (ioutform.eq.0) then
            open(21,file=psiout, status='unknown',form='unformatted')
            open(22,file=coulout,status='unknown',form='unformatted')
            open(23,file=exchout,status='unknown',form='unformatted')
            rewind(23)
         else
            open(21,file=psiout, status='unknown',form='formatted')
            open(22,file=coulout,status='unknown',form='formatted')
            open(23,file=exchout,status='unknown',form='formatted')
            rewind(23)
         endif

      elseif (iform.eq.3) then
         if (inpform.eq.0) then
            open(11,file=psiinp, status='unknown',form='unformatted')
            open(12,file=coulinp,status='unknown',form='unformatted')
            open(13,file=exchinp,status='unknown',form='unformatted')
            rewind(13)
         else
            open(11,file=psiinp, status='unknown',form='formatted')
            open(12,file=coulinp,status='unknown',form='formatted')
            open(13,file=exchinp,status='unknown',form='formatted')
            rewind(13)
         endif

         if (ioutform.eq.0) then
            open(21,file=psiout, status='unknown',form='unformatted')
            open(22,file=coulout,status='unknown',form='unformatted')
            open(23,file=exchout,status='unknown',form='unformatted')
            rewind(23)
         else
            open(21,file=psiout, status='unknown',form='formatted')
            open(22,file=coulout,status='unknown',form='formatted')
            open(23,file=exchout,status='unknown',form='formatted')
            rewind(23)
         endif
      endif

      rewind(11)
      rewind(12)
      rewind(21)
      rewind(22)

c     ini=5 enables to retrieve from complete/uncomplete dump file
c           if only one (the highest= the first) orbital is missing
c           the rest is retreived and the first is initialized as 
c           a hydrogenic one (ini is changed from 5 to 4)

      go to 5




 690  continue

c     label label label label label label label label label label label label label 
c     label: interp



      iflag=0
      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         iord_nu_orb=itmp+1
         call inpi(iord_mu_orb)
         iord_mu_orb=iord_mu_orb+1
         
         call inpi(iord_nu_coul)
         iord_nu_coul=iord_nu_coul+1
         call inpi(iord_mu_coul)
         iord_mu_coul=iord_mu_coul+1

         call inpi(iord_nu_exch)
         iord_nu_exch=iord_nu_exch+1
         call inpi(iord_mu_exch)
         iord_mu_exch=iord_mu_exch+1
      endif
      if ((iord_nu_orb.ne.3).and.(iord_nu_orb.ne.5).and.
     &     (iord_nu_orb.ne.7).and.(iord_nu_orb.ne.9)) goto 1600
      
      if ((iord_mu_orb.ne.3).and.(iord_mu_orb.ne.5).and.
     &     (iord_mu_orb.ne.7).and.(iord_mu_orb.ne.9)) goto 1600
      
      if ((iord_nu_coul.ne.3).and.(iord_nu_coul.ne.5).and.
     &     (iord_nu_coul.ne.7).and.(iord_nu_coul.ne.9)) goto 1600
      
      if ((iord_mu_coul.ne.3).and.(iord_mu_coul.ne.5).and.
     &     (iord_mu_coul.ne.7).and.(iord_mu_coul.ne.9)) goto 1600
      
      if ((iord_nu_exch.ne.3).and.(iord_nu_exch.ne.5).and.
     &     (iord_nu_exch.ne.7).and.(iord_nu_exch.ne.9)) goto 1600
      
      if ((iord_mu_exch.ne.3).and.(iord_mu_exch.ne.5).and.
     &     (iord_mu_exch.ne.7).and.(iord_mu_exch.ne.9)) goto 1600
      
      iinterp=1
      goto 5



 700  continue

c     label label label label label label label label label label label label label 
c     label: lagra

c     scaling and damping factors for off-diagonal Lagrange multipliers

      ftmp=0.d0
      call inpf(ftmp)
      if (ftmp.ne.0.d0) then
         sflagra=ftmp
         ftmp=0.d0
         call inpf(ftmp)
         if (ftmp.ne.0.d0) then
            dflagra=ftmp
         endif
      endif

      goto 5


 710  continue

c     label label label label label label label label label label label label label 
c     label: lagraon

      
      do i=1,2*maxorb,2
         call inpi(itmp1)
         call inpi(itmp2)
         if (itmp1.ne.inpiexit) then 
            if (itmp2.ne.inpiexit) then
               lagraon(i  )=itmp1
               lagraon(i+1)=itmp2
            else
               goto 1700
            endif
         else
            goto 381
         endif
      enddo

c FIXME
 381  continue
      do i=1,2*maxorb,2
         if (lagraon(i)*lagraon(i+1).gt.0) then
            print *,'lagraon: ',lagraon(i),lagraon(i+1)
         endif
      enddo

      goto 5



 720  continue

c     label label label label label label label label label label label label label 
c     label: maxsor

      do iorb=1,norb
         call inpi(itmp1)
         if (itmp1.ne.inpiexit) then
            call inpi(itmp2)
            if (itmp2.ne.inpiexit) then
               maxsor(itmp1)=itmp2
            else
               goto 1700
            endif
         else
            goto 431
         endif
      enddo
 431  continue
      goto 5


 730  continue

c     label label label label label label label label label label label label label 
c     label: method
      
      call inpa(char8)

      ihit=0
      do i=1,nmethods
         if (char8.eq.cmethod(i)) ihit=ihit+1
      enddo
      
      if (ihit.eq.0) goto 1650 

      if (char8.eq.cmethod(1)) imethod=1
      if (char8.eq.cmethod(2)) imethod=2
      if (char8.eq.cmethod(3).or.char8.eq.cmethod(4)) imethod=3
      if (char8.eq.cmethod(5)) imethod=4


c     prepare for HFS calculations
      if (imethod.eq.3) then
         alphaf=two/three
	 islat =1
         idftex=1
c        if imethod=3 then islat=1 and vice versa
c FIXME 
c	 exlexp=1.d0
      endif

c     alpha parameter of the density-functional theory is calculated
c     according to the Self-Consistent Multiplicative Constant method
c     (see V.V.Karasiev and E.V.Ludenia, Self-consistent multiplicative
c     constant method for the exchange energy in density functional
c     theory, Phys. Rev. A 65 (2002) 062510

      if (imethod.eq.4) then
         imethod=3
         iscmc=1   
         alphaf=two/three
         islat =1
         idftex=1
      endif

      goto 5


 740  continue

c     label label label label label label label label label label label label label 
c     label: multipol 

c     define number of multipole moments to be calculated



c     facmul  -  if facmul>0  multipole moment expansion
c		 coefficients are recalculated	every time demax(1),
c		 i.e. maximum error in orbital energy, is reduced by
c		 facmul
c		 if facmul<0 these coefficients are not calculated
c
      call inpf(facmul)
      if (facmul.lt.0.d0) facmul=10.0**(15)
      go to 5



 750  continue

c     label label label label label label label label label label label label label 
c     label: nuclei

      call inpf(z1)
      call inpf(z2)
      call inpf(r)
      call inpa(char8)

c     conversion factor due to Cohen and Taylor (1986)
c     The 1986 Adjustment of the Fundamental Physical Constants

      if (char8.eq.angstrom) r=r/bohr2ang
      r2=r/2.0d0

      if ((abs(z1)+abs(z2)).eq.0.d0.or.r.eq.0.d0) then
         write(iout6,*) 'Error: incomplete input'
         stop 'rinputd'
      endif

c     for HFS method set alpha to a (hopefully) reasonable value based
c     on atomic optimum values due to Schwarz (see blk-data.f)
c     
      if (islat.ne.0) then
         if ( nint(z1).ge.nint(z2) )  then
            alphaf=alphaopt(nint(z1))
         else
            alphaf=alphaopt(nint(z2))
         endif
      endif
      go to 5



 760  continue

c     label label label label label label label label label label label label label 
c     label: omega

c     ovforb   -  overelaxation parameter for orbitals and grids
c     ovfcoul  -  overelaxation parameter for coulomb pot. and grids
c     ovfexch  -  overelaxation parameter for exchange pot. and grids

c     new format
      call inpf(ftmp1)
      call inpf(ftmp2)
      if (ftmp1.gt.0.d0.and.ftmp2.ne.0.d0) then
         ovforb(1)=ftmp1
         ovfcoul(1)=ftmp2
      else
c        old format
         call card
         call inpf(ftmp)
         if (ftmp.gt.0.d0) then
            ovforb(1)=ftmp
         else
            goto 1700
         endif
         
         do ig=2,ngrids
            ovforb(ig) = ovforb(1)
         enddo      
         
         call inpf(ftmp)
         if (ftmp.gt.0.d0) then
            ovforb(2)=ftmp
            call inpf(ftmp)
            if (ftmp.gt.0.d0) then
               ovforb(3)=ftmp
            endif
         endif
         
         call card
         call inpf(ftmp)
         ovfcoul(1)=ftmp
         if (ftmp.gt.0.d0) then
            do ig=2,ngrids
               ovfcoul(ig) = ovfcoul(1)
            enddo
            
            call inpf(ftmp)
            if (ftmp.gt.0.d0) then
               ovfcoul(2)=ftmp
               call inpf(ftmp)
               if (ftmp.gt.0.d0) then
                  ovfcoul(3)=ftmp
               endif
            endif
         else
c           omega values cannot be set automatically for subgrids
            if (ngrids.gt.1) goto 1700
         endif
      endif
      
      do ig=1,ngrids
        ovfexch(ig) = ovfcoul(ig)
      enddo
      goto 5


 770  continue

c     label label label label label label label label label label label label label 
c     label: order

c     iorder  -  type of (mc)sor sweeps (ordering) for each grid
c	= 1   -  natural column-wise ordering for the mesh points
c	= 2   -  'middle' type of sweep - default of 2d-hf program
c	= 3   -  natural row-wise
c	= 4   -  reversed natural (column-wise) ordering (see mesh for details)
c


      do ig=1,ngrids
         call inpi(iorder(ig))
      enddo
      goto 5


 780  continue
c FIXME
c     label label label label label label label label label label label label label 
c     label: print

c     label followed by up to maxflags integers (1..600) specifying
c     additional printouts

c     80 - total radial density along the internuclear axis from the
c          centre A to minus infinity (-rinf)

c     82 - total radial density along the internuclear axis from the
c          centre B to plus infinity (+rinf)

      inzero=1
      do i=1,maxflags
         id(i)=0
         call inpi(id(i))
         if (id(i).gt.0) then
           inzero=inzero+1
           iprint(id(i))=1
        endif
      enddo

      goto 5


 790  continue

c     label label label label label label label label label label label label label 
c     label: scf
c
c     maxscf  - max. no. of scf iterations
c     nobckup - no. of iterations between backups 
c     ienterm - if max. error in orbital energy is less than 
c               1/10**ienterm than scf iterations are terminated
c     inoterm - if max. error in orbital norm is less than 
c               1/10**inoterm than scf iterations are terminated
c     iprtlev - level of output during scf process
c               conv. rate, orbital energy, normalization of the worst
c               converged orbital is printed every nobckup iterations
c               if iprtlev=3 or every scf iteration if iprtlev=2 (default).
c               if iprtlev=1 then conv. rate, orbital energy and normalization 
c               of every orbital is printed in every scf iteration;
c               in any case total energy is printed every nobckup iterations;

      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         maxscf = itmp
         call inpi(itmp)
         if (itmp.ne.inpiexit) then
            nobckup = itmp
            call inpi(itmp)
            if (itmp.ne.inpiexit) then
               ienterm = itmp
               call inpi(itmp)
               if (itmp.ne.inpiexit) then
                  inoterm = itmp
                  call inpi(itmp)
                  if (itmp.ne.inpiexit) then
                     iprtlev=itmp
                  endif
               endif
            endif
         endif
      endif
      goto 5



 800  continue

c     label label label label label label label label label label label label label 
c     label: scforder


      do iorb=1,norb
         call inpi(itmp)
         if (itmp.ne.inpiexit) then
            iscforder(iorb)=itmp
         else
            goto 1700
         endif
      enddo
      goto 5



 810  continue

c     label label label label label label label label label label label label label 
c     label: sor

c     maxsor2 - maximal number of (mc)sor iterations (over each subgrid)
c               during relaxation of every orbital and potential in an SCF cycle

c     lsor    - a scaling factor used to change maxsor2 value when relaxing
c               potentials (see relcoul1/2 and relexch1/2); the number of (mc)sor
c               iterations for the potentials is calculalated as maxsor2/lsor

c     ipoiss  -  choice of poisson's equation solving method
c        = 1     sor (modified LPS's code)
c        = 2     mcsor - variables are relaxed in 5 sweeps each relaxing
c                every 5th variable (145 mflops on Cray Y-MP)


      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         maxsor2 = itmp
         do i=1,norb
            maxsor(i)=maxsor2
         enddo

         call inpi(itmp)
         if (itmp.ne.inpiexit) then
            lsor = itmp
            call inpi(itmp)
            if (itmp.ne.inpiexit) then
               ipoiss = itmp                       
c     maxsor1  -  maximal number of (mc)sor iterations over the whole grid
c                 between which boundary value at infinity are recalculated

c               call inpi(itmp)
c               if (itmp.ne.inpiexit) then
c                  maxsor1 = itmp
c               endif
            endif
         endif
      endif

      goto 5


 820  continue

c     label label label label label label label label label label label label label 
c     label: stop



      write(*,*) '  ... end of input data  ...'
      write(*,*)'        '

      iform_t = iform
      ni_t    = nni
      mu_t    = nmutot
      no_t=norb
      nons_t=0
      do iorb=1,norb
         if (mgx(3,iorb).ne.0) nons_t=nons_t+1
      enddo

c      occ(1)=3.85
      goto 1000


 830  continue

c     label label label label label label label label label label label label label 
c     label: subgrid

c     up to 10 grids can be formally defined (rgrid(10) though
c     rgrid(9) would sufice nmu(10))
c     the last value of rgrid must be equal to rinf, i.e. the practical infinity

c     subgrid option is regarded as obsolete (due to technology
c     advancements and changes in the program) and is not supported 

      write(iout6,*) ' Error: obsolete label. See User''s guide.'
      stop 'rinputd'

      call inpi(ngrids)
      call card
      call inpi(nni)
      nmutot=0
      do ig=1,ngrids
        call inpi(nmu(ig))
        nmutot=nmutot+nmu(ig)
      enddo
 
      if (nni.gt.maxni) then
         write(*,*) 'Error: too many grid points in nu variable'
         stop 'rinputd'
      endif
      if (nmutot.gt.maxmu) then
         write(*,*) 'Error: too many grid points in mu variable'
         stop 'rinputd'
      endif

      call card
      do ig=1,ngrids
        call inpf(rgrid(ig))
      enddo
      rinf=rgrid(ngrids)

      if (ngrids.gt.maxgrids) then
         write(*,*) 'Error: too many subgrids'
         stop 'rinputd'
      endif

c     set default ordering for subgrids

      do ig=1,ngrids
         iorder(ig)=2
      enddo      
      goto 5



 840  continue
c     label label label label label label label label label label label label label 
c     label: title

      read(iinp5,1104,err=1500) header
      write(iout6,1105) header
c      write(iout6,*) header
 1104 format(a80)
 1105 format(2x,a80)
      go to 5



 850  continue

c     label label label label label label label label label label label label label 
c     label: xalpha
c
c      alphaf - if alphaf is not zero a DFT energy functional is used


      ftmp=0.d0
      call inpf(ftmp)
      if (ftmp.ne.0.d0) then
         alphaf = ftmp
      endif
      goto 5


 860  continue
c     label: poth3

      call inpi(mpot)
      call inpf(apot)
      call inpf(v0pot)
      ifermi=3

      goto 5


 870  continue
c     label: potkh

      apot=1.d0
      v0pot=1.d0
      nsimp=1000
      call inpi(mpot)
      call inpf(epspot)
      call inpf(ompot)
      call inpf(tmp1)
      if (tmp1.ne.0.d0) then
         apot=tmp1
         call inpf(tmp2)
         if (tmp2.ne.0.d0) then
            v0pot=tmp2
            call inpi(itmp)
            if (itmp.ne.iniexit) then
               nsimp=itmp
            endif
         endif
      endif
      ifermi=4

      goto 5

 1000 continue

c     winding up

      return


01500 write(iout6,*) 'I/O error detected when reading TITLE card'
      goto 2000

01530 write(iout6,1531) clabel,(labellc(i),i=1,nlabels)
01531 format(1x,'Error: ',a8,' is not a valid label - ',
     &     'try one of the following:',/,
     &     10(8x,a8,2x,a8,2x,a8,2x,a8,2x,a8/))
      goto 2000

01600 write(iout6,*) 'Error: incorrect order of interpolation',
     &     ' polynomial - allowed values are 2, 4, 6 or 8'
C$$$01120 format(1x,'Error: incorrect order of interpolation polynomial',
C$$$     &     'allowed values: 2, 4, 6 or 8')
      goto 2000
01650 write(iout6,*) 'Error: incorrect method - ',
     &     'allowed values are HF, HFS, DFT or OED'
      goto 2000
01700 write(iout6,*) 'Error: missing or incorrect entry - ',
     &     'see User''s guide'
      goto 2000

02000 stop 'rinputd'
      end
