********************************************************************************
*                                                                              * 
*  2DHF version 2-2006                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### scf ####

c     Controls SCF process.

      subroutine scf (cw_sor,cw_orb,cw_coul,cw_exch,cw_suppl,cw_sctch)

      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      logical stop_x2dhf
      integer*4 cw_sor
      parameter (izero=0)
      character*1 str(80)
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),
     &		cw_suppl(*),cw_sctch(*)
      dimension inde(60),demaxt(60)
      equivalence(datetime,str(1))
      dimension iorborder(7)
      common /status/ istat

c     prepare scf process
c     normalize/orthogonalize orbitals, calculate Lagrange multipliers
c     prepare data for boundary value evaluation
c
      call prepscf (cw_sor,cw_orb,cw_coul,cw_exch,cw_suppl,cw_sctch)

      istat=1
      stop_x2dhf=.false.
      ic=0
      thren=10.d0**dble(-ienterm)
      thrno=10.d0**dble(-inoterm)

c     the scf procedure starts here (set some parameters and go ...)

      ddmax=0.d0
      do i=1,norb
         inde(i)=i 
         itouch(i)=0
         demax(i)=100.d0
         demaxt(i)=0.d0
         engi(i)=eng(i)
      enddo
      dnomax=100.d0

      tscf=0.d0
      trelax=0.d0
      tortho=0.d0
      trayl =0.d0
      tlagra=0.d0	
      tmomen=0.d0

      count_thrno=0
      count_max_thrno=5

c     SCF/SOR process is stopped if saturation is achieved 
      ddmaxprev=1.e35
      dnmaxprev=1.e35
      noenergydec=0
      nonormdec=0
      
c     if extension has not been read in recalculated asymptotic values
c     for potentials

      if (idump.ne.0.and.(iform.eq.0.or.iform.eq.3)) iasympt=norb
      
      call ttime (time1)      
      tscf=time1
      
      iscf=0
      
      time1=0.d0
      time2=0.d0
      
      if (ihomon.eq.2) then
	 call homo(izero,cw_orb)
      endif     
      
c     initialize totenp 

      if (iform.eq.0.or.iform.eq.2) then
         iorb=0
         call totenp (iorb,cw_orb,cw_coul,cw_exch,
     &        cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &        cw_suppl(i4b(14)),
     &        cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &        cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &        cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &        cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &        cw_sctch(i5b(13)),cw_sctch(i5b(14)))
      endif
      
c     ----- begin of scf loop -----
      
      ioo=1
      
      if (maxscf.le.0) write(iout6,*) '... skipping scf iterations ...'
      do iscf=1,maxscf

         if (iscf.eq.1) then
            if (iprint16.eq.0) then
               write(iout6,15000)
            else
               write(iout6,25000)
            endif
         endif

c        loop over orbitals (in reverse order) relaxation begins from
c        the innermost orbital, i.e. the last one on the input data list
c        unless iscforder specifies alternative ordering
         
         ibeg=1
         iend=norb
         
c        prepare retrieval of exchange potentials 
         call prepwexch
         
c        ----- begin of orbital loop -----	

c FIXME
         if (iorder(i).eq.5.and.mod(iscf,2).eq.0) then
            ioo=-1
         else
            ioo= 1
         endif

         iasympt=norb
         do i=ibeg,iend
            if (iscforder(i).ne.0) then
               iorb=iscforder(i)
            else
               iorb=norb-i+1
            endif
            

            itouch(iorb)=1
            if (ifix(iorb).ne.0) goto 100

            call ttime (time1)
            if (iform.eq.0.or.iform.eq.2) then
c              retrieve from disk exchange potentials involving iorb	
               call rfdexch(iorb,cw_exch)
C$$$               if (iasympt.ne.0) then
C$$$                  call asymptp(iorb,cw_coul,cw_exch)  
C$$$                  iasympt=iasympt-1
C$$$               endif
            endif

c           calculate off-diagonal Lagrange multipliers

c            call lagra (iorb,cw_orb,cw_coul,cw_exch,
c     &           cw_suppl(i4b(14)),cw_sctch(i5b(1)),cw_sctch(i5b(2)))	

c            if (idbg(300).ne.0) then
            if (iasympt.ne.0) then
               call asymptp(iorb,cw_coul,cw_exch)  
               iasympt=iasympt-1
            endif
c            endif

            call lagra (iorb,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &           cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))


            call ttime(time2)
            trayl =trayl + (time2-time1)	  	  
            call relax (iorb,cw_sor,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 1)),cw_suppl(i4b( 2)),cw_suppl(i4b( 3)),
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b( 6)),  
     &           cw_suppl(i4b( 7)),cw_suppl(i4b( 8)),cw_suppl(i4b( 9)),     
     &           cw_suppl(i4b(10)),cw_suppl(i4b(11)),cw_suppl(i4b(12)),     
     &           cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),          
     &           cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &           cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &           cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &           cw_sctch(i5b(13)),cw_sctch(i5b(14)))
            call ttime (time2)
            trelax=trelax+(time2-time1)

            time1=time2
            call norm (iorb,cw_orb,
     &           cw_suppl(i4b(9)),cw_suppl(i4b(14)),cw_sctch(i5b(1)))

c           enforce C_i symmetry of the orbital

            if (ihomon.eq.2) call homo(iorb,cw_orb)

c FIXME idbg
            iprt=0
            if (norb.gt.1) then
               call ortho (iorb,cw_orb,
     &              cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &              cw_sctch(i5b(1)),iprt)

c              call orthox (iorb,cw_orb,
c     &              cw_suppl(i4b(9)),cw_suppl(i4b(14)),
c     &              cw_sctch(i5b(1)),iprt)

            endif

            call ttime(time2)
            tortho=tortho+(time2-time1)

c           call rotate(iorb,cw_orb,cw_sctch(i5b(1)))	  

c           calculate diagonal energy value
            
            call ttime(time1)
            call rayl (iorb,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &           cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))
            demaxt(iorb)=eng(iorb)-engi(iorb)
            engi(iorb)=eng(iorb)	  

c FIXME
            if (idbg(76).ne.0) then
               call contriborb (iorb,cw_orb,cw_coul,cw_exch,
     &              cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &              cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &              cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &              cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))
            endif
            
            if (iform.eq.0.or.iform.eq.1) then
               call wtdexch(iorb,cw_exch)
            endif

c FIXME            
c            call nodess(iorb,cw_orb)

            if (iprtlev.eq.1) then
               if (iprint16.eq.0) then
                  write(iout6,15100) iscf,iorn(iorb),bond(iorb),
     &                 gut(iorb),eng(iorb),demaxt(iorb),1.0-area(iorb)
c     &                 nodes(iorb,cw_orb)
               else
                  write(iout6,25100) iscf,iorn(iorb),bond(iorb),
     &                 gut(iorb),eng(iorb),demaxt(iorb),1.0-area(iorb)
c     &                 nodes(iorb,cw_orb)
               endif
            endif     

C             if (iscmc.eq.1) then
C                call scmc (cw_orb,cw_coul,cw_exch,
C      &              cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
C      &              cw_suppl(i4b(13)),cw_suppl(i4b(14)),
C      &              cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
C      &              cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))
C             endif


            if (nobckup.gt.0) then
               modv=mod(iscf,abs(nobckup))
               if (modv.eq.0) then
                  if (iform.eq.0.or.iform.eq.2) then

c                    calculate 'intermidiate' total energy
                     
                     call totenp (iorb,cw_orb,cw_coul,cw_exch,
     &                    cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &                    cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &                    cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &                    cw_sctch(i5b( 3)),cw_sctch(i5b( 4)),
     &                    cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &                    cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),
     &                    cw_sctch(i5b( 9)),cw_sctch(i5b(10)),
     &                    cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &                    cw_sctch(i5b(13)),cw_sctch(i5b(14)))

                  endif
               endif
            endif

c       Sometimes a lengthy calculation needs to be stoped earlier. 
c       kill <pid> will do the job but you risk that the data being written 
c       will be lost. To avoid this and force the program to end gracefully 
c       make 
c          touch stop_x2dhf
c       or simply
c          ./xhf stop
        
c       If this file is detected the program ends.
        
            inquire (file ='stop_x2dhf',exist=stop_x2dhf)
            if (stop_x2dhf) goto 110

00100       continue
         enddo

c     ----- end of orbital loop -----	

00110    continue
         demax(1)=0.d0
         inde(1)=1
         indn=1
         dnomax=0.d0
         
         if (norb.gt.0) then
            do nei=1,norb
               if(abs(demaxt(nei)).ge.abs(demax(1))) then
                  demax(1)=demaxt(nei)
                  inde(1)=nei
               endif
            enddo
            do nei=1,norb
               if (abs(1.d0-area(nei)).ge.dnomax) then
                  dnomax=abs(1.d0-area(nei))
                  indn=nei
               endif
            enddo
         endif	
         
c        inde containes indexes of orbitals in the order of their state
c        of convergence; inde(1) points to the worst converged orbital
      
         if (ddmax.eq.0.d0) ddmax=demax(1)
         
         if (iprtlev.eq.2) then 
            if (iprint16.eq.0) then
               write(iout6,15110) iscf,iorn(inde(1)),bond(inde(1)),  
     &              gut(inde(1)),eng(inde(1)),demaxt(1),1.0-area(indn)
               else
                  write(iout6,25100) iscf,iorn(inde(1)),bond(inde(1)),  
     &              gut(inde(1)),eng(inde(1)),demaxt(1),1.0-area(indn)
               endif
                  
         endif


         if (iscmc.eq.1) then
C             call scmc (cw_orb,cw_coul,cw_exch,
C      &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
C      &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
C      &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
C      &           cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))

               call scmc (cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &           cw_sctch(i5b( 3)),cw_sctch(i5b( 4)),
     &           cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &           cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),
     &           cw_sctch(i5b( 9)),cw_sctch(i5b(10)),
     &           cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &           cw_sctch(i5b(13)),cw_sctch(i5b(14)))
         endif



c     calculate and print various contributions to total energy
         if (idbg(75).ne.0) then
            call contrib (cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &           cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))
         endif


c         call swaporb(cw_orb,cw_sctch(i5b(1)))


C c     check orthogonalization
C       call checkorthog(cw_orb,cw_suppl(i4b(9)),cw_suppl(i4b(14)),
C      &        cw_sctch(i5b(1)),cw_sctch(i5b(2)))

C       stop

c     Sometimes the convergence threshold (for energy and/or
c     normalization) is set too low and cannot be satisfied on a given
c     grid and as a result the SCF/SOR process continues in vain. To
c     avoid these excessive iterations the convergence process is
c     stopped if either demax(1) or dnomax has not decreased over a
c     given number (nlast) most recent iterations.

c     skip nscf2skip iterations before starting the search for
c     saturation; examine the last nenlast and nnolast iterations in case
c     of orbital energy and normalization, respectively

         if (iscf.gt.nscf2skip) then
            if (abs(demax(1)).ge.abs(ddmaxprev)) then
               noenergydec=noenergydec+1
            else
               ddmaxprev=demax(1)
               noenergydec=0
            endif
         if (abs(dnomax).ge.abs(dnmaxprev)) then
            nonormdec=nonormdec+1
         else
            dnmaxprev=dnomax
            nonormdec=0
         endif
c         print *,noenergydec,nonormdec,ddmaxprev,dnmaxprev
         if (noenergydec.gt.nenlast.or.nonormdec.gt.nnolast) then
            write(*,*) '          '
            write(*,*) '... solution cannot be further improved ...'
            goto 9999
         endif
      else
         ddmaxprev=demax(1)
         dnmaxprev=dnomax
      endif


      if (iscforder(i).ne.0) then
c        tests suggest that reordering of orbitals is not going to speed
c        up the convergence of scf process
         call setordnorm
      endif

         

c     check if the scf process is to be continued 

      if (abs(demax(1)).gt.diver) then
         write(*,*) '           '
         write(*,*) '... maximal orbital energy error is too ',
     &        'large ...'
         goto 9999
      endif

      if (iscf+1.gt.maxscf) then
         write(*,*) '          '
         write(*,*) '... scf iteration limit reached ... '
         goto 9999
      endif
         
      if (abs(demax(1)).lt.thren) then
         write(*,*) '          '
         write(*,*) '... orbital energy threshold reached ...'
         goto 9999
      endif
C       elseif (exlorb.eq.0.and.dnomax.lt.thrno) then
C          if (count_thrno.gt.count_max_thrno) then
C             write(*,*) '          '
C             write(*,*) '... orbital normalization threshold',
C      &           ' reached ...'
C             goto 9999
C          else
C             count_thrno=count_thrno+1
C          endif

      if ( thrno.ne.0.d0 ) then
         if (exlorb.eq.0.and.dnomax.lt.thrno) then
            write(*,*) '          '
            write(*,*) '... orbital normalization threshold',
     &           ' reached ...'
            goto 9999
         endif
      endif
   
      if (stop_x2dhf) then
         write(*,*) '          '
         write(*,*) '... stop_x2dhf detected ... '
         write(*,*) '... program is terminating ...'
         write(*,*)
         goto 9999
      endif
        
c     write functions to disk file if nobckup > 0
      
      if (nobckup.gt.0) then
         modv=mod(iscf,nobckup)
         if (modv.eq.0) then
            call wtdisk(cw_orb,cw_coul,cw_exch)
            if (iprtlev.eq.3) write(iout6,15110) 
     &           iscf,iorn(inde(1)),bond(inde(1)),gut(inde(1)),
     &           eng(iorb),demaxt(iorb),1.0-area(iorb)
            if (iform.eq.1.or.iform.eq.3) then
               
c              calculate 'intermidiate' total energy
               
               call toten (cw_orb,cw_coul,cw_exch,
     &              cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &              cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &              cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &              cw_sctch(i5b( 3)),cw_sctch(i5b( 4)),
     &              cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &              cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),
     &              cw_sctch(i5b( 9)),cw_sctch(i5b(10)),
     &              cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &              cw_sctch(i5b(13)),cw_sctch(i5b(14)))
            endif
            write(iout6,6100)  etot
         endif
      endif	  
      
c     recalculate multipole moments expansion coefficients
      
      if (abs(ddmax/demax(1)).gt.facmul.or.
     &     abs(demax(1)/ddmax).gt.facmul) then
         call momen(cw_orb,cw_suppl,cw_sctch)

         ddmax=demax(1)

c        recalculate asymptotic values of potentials
         
C$$$         if (iform.eq.1.or.iform.eq.3) then
C$$$            call asympot (cw_coul,cw_exch)	  
C$$$         else
C$$$            iasympt=norb
C$$$         endif
         
         iasympt=norb
         
c         if (idbg(300).ne.0) iasympt=norb

         do iorb=1,norb
            itouch(iorb)=0
         enddo	    
      endif
      call flush(iout6)
      
c     to run a job in a bach mode (or in the background) with
c     the output redirected into a file and to monitor every single
c     iteration 

      enddo

c     ----- end of scf loop	-----
      
09999 iscf=iscf-1
      call summary (iscf,cw_orb,cw_coul,cw_exch,cw_suppl,cw_sctch)
      
      call ttime (time1)      
      tscf=time1-tscf
      write(*,5010) tscf
      datetime=dtstart
      write(*,'(//,1x,a7,80a1)') 'start: ',(str(i),i=1,24)
      call  getdatetime(datetime)
      write(*,'(1x,a7,80a1)') 'stop:  ',(str(i),i=1,24)
      write(*,'("////////////////////////////////////////////",
     &     "////////////////////////////////////////////////////")')
      
 1300 format(/,80a1)	
 5010 format(4x,'total time in scf routine          ', f12.2)
 6100 format(1x,'total energy: ',e26.16)
15000 format(/'  iter.   orbital',9x,'   energy  ',12x,'energy diff.',
     &         7x,'1-norm')
15100 format(i5,i4,1x,a8,a1,2x,e22.16,2e16.2,i5)
15110 format(i5,i4,1x,a8,a1,3x,e22.16,2e16.2,i5)
25000 format(/'  iter.   orbital',24x,'   energy  ',19x,'energy diff.',
     &         7x,'1-norm')
25100 format(i5,i4,1x,a8,a1,2x,e44.32,2e16.2,i5)

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### checkorthog ###
c
c     Check orthonormalization
c
      subroutine checkorthog (psi,f4,wgt2,wk0,ovrlap1)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),f4(*),wgt2(*),wk0(*)
      dimension  ovrlap1(60,60)
      dimension  ovrlap(60,60)

      print *,''
      print *,'... checking orthogonalization ...'
      print *,''
      do iorb1=norb,1,-1
         ibeg1=i1b (iorb1)
         do iorb2=norb,1,-1
            if (iorb2.gt.iorb1) go to 90
            ngrid= min (i1si(iorb1),i1si(iorb2))	  	    
            if (mgx(6,iorb2).ne.mgx(6,iorb1)) go to 90
            if (ige(iorb2).ne.ige(iorb1)) go to 90
            ibeg2=i1b (iorb2)
            
            call prod2 (ngrid,psi(ibeg1),psi(ibeg2),wk0)
            call prod  (ngrid,f4,wk0)

            
            ovrlap(iorb1,iorb2)=ddot (ngrid,wgt2,1,wk0,1)
            ovrlap(iorb2,iorb1)=ovrlap(iorb1,iorb2)

            i=iorb1
            j=iorb2
            write(*,60) iorn(i),bond(i),gut(i),
     &              iorn(j),bond(j),gut(j),ovrlap(i,j)

 90         continue
         enddo
      enddo
      return
c     write final overlap
      
      do i=norb,1,-1
         do j=i,1,-1
            if (ll(i).eq.ll(j).and.ige(i).eq.ige(j)) then
               write(*,60) iorn(i),bond(i),gut(i),
     &              iorn(j),bond(j),gut(j),ovrlap(i,j)
            endif
         enddo
         print *,''
      enddo
      
 60   format(4x,' <',i2,1x,a5,1x,a1,1x,'|',
     &     1x,i2,1x,a5,1x,a1,1x,'> = ',e15.5)     
      
      return 
      end
 
      subroutine setordereng
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension engtmp(60)
      do i=1,norb
         engtmp(i)=eng(i)
      enddo
      
      imin=1
      emin=0.d0
      do i=1,norb
         imin=i
         emin=0.d0
         do j=1,norb
            if (engtmp(j).lt.emin) then
               imin=j
               emin=engtmp(j)
c               print *,i,j,engtmp(j)
            endif
         enddo
         engtmp(imin)=0
         iscforder(i)=imin
      enddo
c      print *,(eng(i),i=1,norb)
c      print *,(iscforder(i),i=1,norb)
c      stop
      return
      end


      subroutine setordnorm
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension engtmp(60)
      do i=1,norb
         engtmp(i)=abs(1.d0-area(i))
      enddo
      
      imin=1
      do i=1,norb
         imin=i
         emin=-1.d0
         do j=1,norb
            if (engtmp(j).gt.emin) then
               imin=j
               emin=engtmp(j)
c               print *,i,j,engtmp(j)
            endif
         enddo
         engtmp(imin)=-1.d0
         iscforder(i)=imin
      enddo
c      print *,(abs(1.d0-area(i)),i=1,norb)
c      print *,(iscforder(i),i=1,norb)
c      stop
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 2-2006                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
      integer*4 function nodes (iorb,psi)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*)

      ibeg = i1b (iorb)
      ngrid= i1si(iorb)

      eps=1.d-14
      maxnodes=0
      do in=1,nni,5
         nodes=0
         inioff1=0
         igp1=ibeg+inioff1+in-1
         psi1=psi(igp1)
         do imu=2,mxnmu
            inioff2=(imu-1)*nni
            igp2=ibeg+inioff2+in-1
            psi2=psi(igp2)
            if (psi1*psi2.lt.0.d0.and.abs(psi1)+abs(psi2).gt.eps) then
               nodes=nodes+1
c               print *,in,imu,psi1,psi2
            endif
            inioff1=inioff2
            igp1=igp2
            psi1=psi2
         enddo
         if (nodes.gt.maxnodes) maxnodes=nodes
      enddo

      nodes=maxnodes
      return
      end


      subroutine nodess (iorb,psi)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*)

      ibeg = i1b (iorb)
      ngrid= i1si(iorb)


      eps=1.d-14
      maxnodes=0
      do in=1,nni,5
         nodes=0
         inioff1=0
         igp1=ibeg+inioff1+in-1
         psi1=psi(igp1)
         do imu=2,mxnmu
            inioff2=(imu-1)*nni
            igp2=ibeg+inioff2+in-1
            psi2=psi(igp2)
            if (psi1*psi2.lt.0.d0.and.abs(psi1)+abs(psi2).gt.eps) then
               nodes=nodes+1
c               print *,in,imu,psi1,psi2
            endif
            inioff1=inioff2
            igp1=igp2
            psi1=psi2
         enddo
         if (nodes.gt.maxnodes) maxnodes=nodes
      enddo
         
c      print *,'orb,maxnodes ',iorb,maxnodes

      return
      end

      subroutine swaporb (psi,wk)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),wk(*)

      iorb1=1
      n1=nodes(iorb1,psi)
      iorb2=2
      n2=nodes(iorb2,psi)

      if (n1.ge.n2) then
         print *,'swaporb: node1,node2',n1,n2
         return
      endif

      ibeg1 = i1b (iorb1)
      ibeg2 = i1b (iorb1)
      ngrid= i1si(iorb1)
      call dcopy (ngrid,psi(ibeg1),ione,wk,ione)
      call dcopy (ngrid,psi(ibeg2),ione,psi(ibeg1),ione)
      call dcopy (ngrid,wk,ione,psi(ibeg1),ione)

      print *,'swaporb: orbitals 1 and 2 were interchanged '

         
      return
      end


 
