********************************************************************************
*                                                                              * 
*  2DHF version 2-2006                                                         *
*  Copyright (C) 2006 Jacek Kobus                                              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### summary ####
c
c     Prints total energy and its components, orbital energies, multipole
c     moments, etc upon completion of the SCF process

      subroutine summary (iscf,cw_orb,cw_coul,cw_exch,
     &     cw_suppl,cw_sctch)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)

      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),
     &     cw_suppl(*),cw_sctch(*)

c     write functions to disk file if nobckup < 10000

      if (nobckup.ge.0) then
         call wtdisk(cw_orb,cw_coul,cw_exch)
      endif

c     calculate final total energy

      write (*,*)
      call toten (cw_orb,cw_coul,cw_exch,                         
     &     cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &     cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &     cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &     cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &     cw_sctch(i5b(13)),cw_sctch(i5b(14)))

      call prttoten

      etot_final=etot

      if (iprint16.eq.0) then
         if (islat.eq.0) then

c FIXME print DFT functional used

            write(*,*)
            write(*,'(" total energy contributions: ")')
            write(*,'("     nuclear-electron attraction energy = ",
     &                                     f18.12)') ennucel
            write(*,'("     kinetic energy                     = ",
     &                                     f18.12)') enkin
            write(*,'("     one electron energy                = ",
     &                                     f18.12)') enkin+ennucel
            write(*,'("     coulomb energy                     = ",
     &                                     f18.12)') encoul
            write(*,'("     exchange energy                    = ",
     &                                     f18.12)') enexch
            write(*,'("     coulomb energy (DFT)               = ",
     &                                     f18.12)') encouldft
            write(*,'("     exchange energy (DFT)              = ",
     &                                     f18.12)') enexchdft
            write(*,'("     correlation energy (DFT)           = ",
     &                                     f18.12)') edftcorr
c         write(*,'("     total energy                       = ",
c     &                                         f18.12)') entot
         else

c FIXME print DFT functional used

            write(*,*)
            write(*,'(" total energy contributions: ")')
            write(*,'("     nuclear-electron attraction energy = ",
     &                                     f18.12)') ennucel
            write(*,'("     kinetic energy                     = ",
     &                                     f18.12)') enkin
            write(*,'("     one electron energy                = ",
     &                                     f18.12)') enkin+ennucel
            write(*,'("     coulomb energy (DFT)               = ",
     &                                     f18.12)') encouldft
            write(*,'("     exchange energy (DFT)              = ",
     &                                     f18.12)') enexchdft
            write(*,'("     correlation energy (DFT)           = ",
     &                                     f18.12)') edftcorr
c         write(*,'("     total energy                       = ",
c     &                                         f18.12)') entot
         endif
      else

         if (islat.eq.0) then

c FIXME print DFT functional used

            write(*,*)
            write(*,'(" total energy contributions: ")')
            write(*,'("     nuclear-electron attraction energy = ",
     &                                     f28.22)') ennucel
            write(*,'("     kinetic energy                     = ",
     &                                     f28.22)') enkin
            write(*,'("     one electron energy                = ",
     &                                     f28.22)') enkin+ennucel
            write(*,'("     coulomb energy                     = ",
     &                                     f28.22)') encoul
            write(*,'("     exchange energy                    = ",
     &                                     f28.22)') enexch
            write(*,'("     coulomb energy (DFT)               = ",
     &                                     f28.22)') encouldft
            write(*,'("     exchange energy (DFT)              = ",
     &                                     f28.22)') enexchdft
            write(*,'("     correlation energy (DFT)           = ",
     &                                     f28.22)') edftcorr
c         write(*,'("     total energy                       = ",
c     &                                         f28.22)') entot
         else

c FIXME print DFT functional used

            write(*,*)
            write(*,'(" total energy contributions: ")')
            write(*,'("     nuclear-electron attraction energy = ",
     &                                     f28.22)') ennucel
            write(*,'("     kinetic energy                     = ",
     &                                     f28.22)') enkin
            write(*,'("     one electron energy                = ",
     &                                     f28.22)') enkin+ennucel
            write(*,'("     coulomb energy (DFT)               = ",
     &                                     f28.22)') encouldft
            write(*,'("     exchange energy (DFT)              = ",
     &                                     f28.22)') enexchdft
            write(*,'("     correlation energy (DFT)           = ",
     &                                     f28.22)') edftcorr
c         write(*,'("     total energy                       = ",
c     &                                         f28.22)') entot
         endif

      endif

      if (idft.eq.1) then
      
         islat=1
         imethod=3
         idftex=1
         call toten (cw_orb,cw_coul,cw_exch,                         
     &        cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &        cw_suppl(i4b(14)),
     &        cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &        cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &        cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &        cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &        cw_sctch(i5b(13)),cw_sctch(i5b(14)))

         write(*,*)
         if (iprint16.eq.0) then
            write(*,'("     Exch tot contrib: LDA  = ",
     &                                     f18.12)') enexchdft
         else
            write(*,'("     Exch tot contrib: LDA  = ",
     &                                     f28.22)') enexchdft
         endif

         idftex=2
         call toten (cw_orb,cw_coul,cw_exch,                         
     &        cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &        cw_suppl(i4b(14)),
     &        cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &        cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &        cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &        cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &        cw_sctch(i5b(13)),cw_sctch(i5b(14)))

         if (iprint16.eq.0) then
            write(*,'("     Exch tot contrib: B88  = ",
     &                                     f18.12)') enexchdft
            else
            write(*,'("     Exch tot contrib: B88  = ",
     &                                     f28.22)') enexchdft
            endif

         idftex=3
         call toten (cw_orb,cw_coul,cw_exch,                         
     &        cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &        cw_suppl(i4b(14)),
     &        cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &        cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &        cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &        cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &        cw_sctch(i5b(13)),cw_sctch(i5b(14)))

         if (iprint16.eq.0) then
            write(*,'("     Exch tot contrib: PW86 = ",
     &                                     f18.12)') enexchdft
         else
            write(*,'("     Exch tot contrib: PW86 = ",
     &                                     f28.22)') enexchdft
         endif

         idftex=4
         call toten (cw_orb,cw_coul,cw_exch,                         
     &        cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &        cw_suppl(i4b(14)),
     &        cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &        cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &        cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &        cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &        cw_sctch(i5b(13)),cw_sctch(i5b(14)))

         if (iprint16.eq.0) then
            write(*,'("     Exch tot contrib: PW91 = ",
     &                                     f18.12)') enexchdft
         else
            write(*,'("     Exch tot contrib: PW91 = ",
     &                                     f28.22)') enexchdft
         endif


         idftcorr=1
         call toten (cw_orb,cw_coul,cw_exch,                         
     &        cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &        cw_suppl(i4b(14)),
     &        cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &        cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &        cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &        cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &        cw_sctch(i5b(13)),cw_sctch(i5b(14)))

         if (iprint16.eq.0) then
            write(*,'("     Corr tot contrib: LYP  = ",
     &                                     f18.12)') enexchdft
         else
            write(*,'("     Corr tot contrib: LYP  = ",
     &                                     f28.22)') enexchdft
         endif


         idftcorr=2
         call toten (cw_orb,cw_coul,cw_exch,                         
     &        cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &        cw_suppl(i4b(14)),
     &        cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &        cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &        cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &        cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &        cw_sctch(i5b(13)),cw_sctch(i5b(14)))

         if (iprint16.eq.0) then
            write(*,'("     Corr tot contrib: VWN  = ",
     &                                     f18.12)') enexchdft
         else
            write(*,'("     Corr tot contrib: VWN  = ",
     &                                     f28.22)') enexchdft
         endif

      endif


c     write final orbital energies and normalization factors
      
      write(*,*)
c      iprint16=1
      if (iprint16.eq.0) then
         write(iout6,1000)
         do i=1,norb
            write(iout6,1002) iorn(i),bond(i),gut(i),eng(i),1.0-area(i)
         enddo
      else
         write(iout6,7000)
         do i=1,norb
            write(iout6,7002) iorn(i),bond(i),gut(i),eng(i),1.0-area(i)
         enddo  
      endif
      write(*,*)

c     check how an error in the orbital normalization factors influences
c     the accuracy of the total energy

c     denormalize orbitals (they leave SCF process properly normalized) 
      do iorb=1,norb
         ibeg = i1b (iorb)
         ngrid= i1si(iorb)
         xnorm=area(iorb)
         zarea = sqrt(xnorm)
         call dscal (ngrid,zarea,cw_orb(ibeg),1)
      enddo  

c     calculate final total energy
      write (*,*)
      etot_final=etot

c FIXME

       call toten (cw_orb,cw_coul,cw_exch,                         
     &     cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &     cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &     cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &     cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &     cw_sctch(i5b(13)),cw_sctch(i5b(14)))

      write(iout6,6111)  abs(etot_final-etot),
     &     abs(etot_final/etot-1.d0)*100

c     normalize orbitals again to bring them to the previous state
      do iorb=1,norb
         ibeg = i1b (iorb)
         ngrid= i1si(iorb)
         xnorm=area(iorb)
         zarea = 1.d0/sqrt(xnorm)
         call dscal (ngrid,zarea,cw_orb(ibeg),1)
      enddo  
 
      
c     check orthohonality
c FIXME
      if (idbg(210).ne.0) then
         write(*,*) 'checking orthogonality:'
         iprt=2
         do iorb=1,norb
            i=norb+1-iorb
            call ortho (i,cw_orb,
     &           cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b(1)),iprt)
         enddo
      endif

c     check symmetry of orbitals in the homonuclear case
      
      if (abs(z1-z2).lt.homolevl) call homo_check(cw_orb)

c      call orbtails (cw_orb,cw_coul,cw_exch,cw_suppl,cw_sctch)
      
      if (idbg(495).ne.0) then
         write(*,*)
         write(*,*) 'Euclidean norms of (T+V(n)+V-E)|i>:'
         do iorb=1,norb
            call locenergy (iorb,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b( 9)),
     &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &           cw_sctch(i5b( 4)))
         enddo
      endif

c     check multipole expansion
      if (idbg(302).ne.0) then
         call chasympot (cw_coul,cw_exch)
      endif

c     calculate multipole moments and expectation values

      if (idbg(211).eq.1) then 
      call propet1 (iscf,cw_orb,cw_coul,cw_exch,cw_suppl(i4b( 9)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),          
     &     cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)))
      endif
      if (idbg(212).eq.0) then
      call propet2 (iscf,cw_orb,cw_coul,cw_exch,cw_suppl(i4b( 9)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),          
     &     cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)))
      endif
      if (idbg(213).eq.1) then
      call propet  (iscf,cw_orb,cw_coul,cw_exch,cw_suppl(i4b( 9)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),          
     &     cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)))
      endif

      if (idbg(570).ne.0) then
         inuclder=0
         if (inuclder.eq.0) then
            call nuclder(cw_orb,
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &           cw_sctch(i5b( 3)),cw_sctch(i5b( 4)),
     &           cw_sctch(i5b( 5)),cw_sctch(i5b( 6)))     
         endif
      endif

      if (islat.eq.1) then
         call scmc (cw_orb,cw_coul,cw_exch,
     &     cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &     cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),
     &     cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),
     &     cw_sctch(i5b(10)),cw_sctch(i5b(11)),cw_sctch(i5b(12)),
     &     cw_sctch(i5b(13)),cw_sctch(i5b(14)))
      endif

c     Calculates the total radial densities relative to centres A
c     (z-R/2) and B (z+R/2)

      call radialden(cw_orb)

      write(*,'(//,"////////////////////////////////////////////",
     &     "////////////////////////////////////////////////////")')

c     CPU time statistics
      
      tcpu=trelax+tortho+trayl+tmomen

      write(*,'(/," cpu summary (sec):")')
      write(*,5001) trelax
      write(*,5002) tortho
      write(*,5003) trayl
      write(*,5004) tmomen
      write(*,5005) tcpu
      if (iscf.ne.0) write(*,5006) tcpu/dble(iscf)
      
c 1000 format(19x,'     orbital energies         normalization factors')  
c 1000 format(29x,'energy',21x,'1-norm')  
 1000 format(7x,'orbital',15x,'energy',21x,'1-norm')  
c 1002 format(1x,i3,1x,a8,1x,a1,2e28.16)
 1002 format(1x,i3,1x,a8,1x,a1,e28.16,e20.2)
 5001 format(4x,'relaxation of orb. and pot.        ', f12.2)
 5002 format(4x,'normalization+orthogonalization    ', f12.2)
 5003 format(4x,'lagrange multipliers               ', f12.2)
 5004 format(4x,'multipole moments                  ', f12.2)
 5005 format(4x,'sum total                          ', f12.2)
 5006 format(4x,'duration of single scf iteration   ', f12.2)
 6100 format(1x,'total electronic energy: ',e28.16)
 6110 format(1x,'total energy:            ',e28.16)
 6111 format(1x,'total energy uncertainty due to orbital norms',
     &     ' not being equal 1:'/,5x,
     &     'absolute = +/-',e8.2,',  relative = +/-',e8.2,'%')
 6120 format(1x,'virial ratio:            ',e28.16)

c 7000 format(36x,'energy',30x,'1-norm')  
 7000 format(7x,'orbital',22x,'energy',30x,'1-norm')  
 7002 format(1x,i3,1x,a8,1x,a1,e44.32,2e20.2)
 7100 format(1x,'total electronic energy: ',e44.32)
 7110 format(1x,'total energy:            ',e44.32)
 7111 format(1x,'total energy uncertaininty due to orbital norms',
     &     ' not being equal 1:'/,
     &     '  absolute   +/-',e8.2,/,
     &     '  relative   +/-',e8.2,'%')
 7120 format(1x,'virial ratio:            ',e44.32)

      return
      end










