********************************************************************************
*                                                                              * 
*  2DHF version 2-2006                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zasyx ###

c     Evaluates asymptotic values of a given exchange potential from the
c     multipole expansion.

c     excptail array is used to provide asymptotic values for 'immersed'
c     exchange potentials (see fill).

c     For odd values of q in P(k,q) (here q=idel) there should be no
c     (-1)**q factor in eq. (19). That is why this factor is missing in
c     this routine.

      subroutine zasyx (idel,ipc,excp)
      implicit integer*4 (i-n)
      implicit real*8(a-h,o-z)
      include 'commons8.inc'
      include 'commons8a.inc'
      dimension excp(*),pe(maxmpole)
      vxil(j) =cosh(dble(j-1)*hmu(1))

      do j=mxnmu-3,mxnmu
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
            call multi(i,j,idel,ipc,pe)
            excp(kk)= r2*vxi(j)*pe(mpole)
         enddo
      enddo

      do j=mxnmu+1,mxnmu+4
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
            call multitail(i,j,idel,ipc,pe)
            excptail(itail(3),i,j-mxnmu)=r2*vxil(j)*pe(mpole)
         enddo
      enddo

      return
      end
