********************************************************************************
*                                                                              * 
*  2DHF version 2-2006                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zmulti ###	
c
c     mpole multipole moments (stored in cmulti) and associated Legendre
c     functions are used to calculate for each i=1,nni 4 boundary values
c     of Coulomb potential for a given orbital, i.e. values for
c     j=mxnmu-3, mxnmu-2, mxnmu-1,mxnmu 
c     
      subroutine zmulti(iorb,pot)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      include 'commons8a.inc'
      dimension pot(*),dome(10)
      vxil(j) =cosh(dble(j-1)*hmu(1))

c     coultail array is used to provide asymptotic values for 'immersed'
c     Coulomb potentials (see fill).

      do j=mxnmu-3,mxnmu
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
            rr=sqrt(vxisq(j)+vetasq(i)-1.d0)
            cost=veta(i)*vxi(j)/rr
            rr1=1.d0/(rr*r2)
            
            dome(1)=cost
            dome(2)=(3.d0*cost*cost-1.d0)*5.d-01
            do n=2,(mpole-1)
               dome(n+1)=(dble(2*n+1)*cost*dome(n)-dble(n)*
     &              dome(n-1))/dble(n+1)
            enddo
            
            pe=0.d0
            do m=1,mpole
               kxk=iorb+(m-1)*norb
               pe=pe+cmulti(kxk)*dome(m)*(rr1**dble(m+1))
            enddo 
            pot(kk)=r2*vxi(j)*(pe+rr1)	  
         enddo
      enddo

      do j=mxnmu+1,mxnmu+4
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
            rr=sqrt(vxil(j)*vxil(j)+vetasq(i)-1.d0)
            cost=veta(i)*vxil(j)/rr
            rr1=1.d0/(rr*r2)
            
            dome(1)=cost
            dome(2)=(3.d0*cost*cost-1.d0)*5.d-01
            do n=2,(mpole-1)
               dome(n+1)=(dble(2*n+1)*cost*dome(n)-dble(n)*
     &              dome(n-1))/dble(n+1)
            enddo
            
            pe=0.d0
            do m=1,mpole
               kxk=iorb+(m-1)*norb
               pe=pe+cmulti(kxk)*dome(m)*(rr1**dble(m+1))
            enddo 
            coultail(iorb,i,j-mxnmu)=r2*vxil(j)*(pe+rr1)	  
         enddo
      enddo

      return
      end
